#include <windows.h>
#include <stdlib.h>
#include "win026.h"

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

int Alea(int min, int max);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "Icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "Icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 026",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           650,
           300,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static WORD vectorizar;
    static WORD trazado;
    static HBRUSH pincel;
    static HFONT fuente;
    HFONT anterior;
    int x, y, i;
    COLORREF color;
    SIZE tam;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           fuente = CreateFont(-120, 0, 0, 0, 300, FALSE, FALSE, FALSE,
              DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
              PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Arial");
           trazado = CM_TRAZADO;
           vectorizar = FALSE;
           pincel = CreateSolidBrush(RGB(255,0,0));
           break;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           SelectObject(hdc, pincel);
           anterior = SelectObject(hdc, fuente);
           BeginPath(hdc);
           SetBkMode(hdc, TRANSPARENT);
           TextOut(hdc, 10,10, "Con Clase", 9);
           EndPath(hdc);
           if(vectorizar) FlattenPath(hdc);
           switch(trazado) {
              case CM_TRAZADO:
                 StrokePath(hdc);
                 break;
              case CM_AMBAS:
                 StrokeAndFillPath(hdc);
                 break;
              case CM_RELLENADO:
                 FillPath(hdc);
                 break;
           }
           SelectObject(hdc, anterior);
           EndPaint(hwnd, &ps);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_CLIP:
                 hdc = GetDC(hwnd);
                 SelectObject(hdc, pincel);
                 anterior = SelectObject(hdc, fuente);
                 BeginPath(hdc);
                 SetBkMode(hdc, TRANSPARENT);
                 TextOut(hdc, 10,10, "Con Clase", 9);
                 EndPath(hdc);
                 GetTextExtentPoint32(hdc, "Con Clase", 9, &tam);
                 SelectClipPath(hdc, RGN_AND);
                 for(i=0; i < 100000; i++) {
                    x = Alea(0,tam.cx);
                    y = Alea(0,tam.cy);
                    color = RGB(Alea(0,256), Alea(0,0), Alea(0,0));
                    SetPixelV(hdc, 10+x, 10+y, color);
                 }
                 SelectObject(hdc, anterior);
                 ReleaseDC(hwnd, hdc);
                 break;
                 case CM_TRAZADO:
                 case CM_RELLENADO:
                 case CM_AMBAS:
                    trazado = LOWORD(wParam);
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
                 case CM_FLATTEN:
                    vectorizar = TRUE;
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
                 case CM_NOFLATTEN:
                    vectorizar = FALSE;
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(fuente);
           DeleteObject(pincel);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

int Alea(int min, int max) {
   int valores = max - min;

   return min + valores*rand()/(RAND_MAX+1);
}

