#include <windows.h>
#include <stdlib.h>
#include "win027.h"

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

int Alea(int min, int max);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "Icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "Icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 027",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           500,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static HBRUSH pincel1;
    static HBRUSH pincel2;
    static HPEN pluma1;
    RECT re;
    HRGN region;
    int x,y,i;
    static int paso;
    COLORREF color;
    static POINT puntos[] = {{100,100},
                      {150,50},{250,50},{300,100},
                      {250,150},{250,250},{300,300},
                      {250,350},{150,350},{100,300},
                      {150,250},{150,150},{100,100}};

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           pincel1 = CreateSolidBrush(RGB(255,0,0));
           pincel2 = CreateSolidBrush(RGB(0,0,255));
           pluma1 = CreatePen(PS_SOLID,1,RGB(0,255,0));
           paso = 10;
           break;
        case WM_PAINT:
           if(paso > 2) paso--;
           else paso = 10;
           hdc = BeginPaint(hwnd, &ps);
           if(paso%2) SelectObject(hdc, pincel1);
           else SelectObject(hdc, pincel2);
           GetClientRect(hwnd, &re);
           Rectangle(hdc, re.left, re.top, re.right, re.bottom);
           if(paso%2)
              for(x = 0; x < re.right; x+=paso) {
                 MoveToEx(hdc, x,0,NULL);
                 LineTo(hdc, x, re.bottom);
              }
           else
              for(x = 0; x < re.right; x+=paso) {
                 MoveToEx(hdc, 0,x,NULL);
                 LineTo(hdc, re.right, x);
              }
           //Rectangle(hdc, re.left, re.top, re.right, re.bottom);
           EndPaint(hwnd, &ps);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_RECTANGULO:
                 for(x=0; x < 10; x++)
                    for(y = 0; y < 10; y++)
                       if((x+y)%2) {
                          SetRect(&re, x*50,y*50,50+x*50,50+y*50);
                          InvalidateRect(hwnd, &re, TRUE);
                       }
                 break;
              case CM_REGION:
                 for(x=0; x < 10; x++)
                    for(y = 0; y < 10; y++)
                       if((x+y+1)%2) {
                          region = CreateEllipticRgn(x*50,y*50,(x+1)*50,(y+1)*50);
                          InvalidateRgn(hwnd, region, TRUE);
                       }
                 DeleteObject(region);
                 break;
              case CM_RECPATH:
                 hdc = GetDC(hwnd);
                 SelectObject(hdc, pincel1);
                 BeginPath(hdc);
                 PolyBezier(hdc, puntos, 13);
                 EndPath(hdc);
                 SelectClipPath(hdc, RGN_AND);
                 for(i=0; i < 100000; i++) {
                    x = Alea(100,300);
                    y = Alea(50,350);
                    color = RGB(Alea(0,256), Alea(0,0), Alea(0,0));
                    SetPixelV(hdc, x, y, color);
                 }
                 ReleaseDC(hwnd, hdc);
                 break;
              case CM_RECREGION:
                 hdc = GetDC(hwnd);
                 SelectObject(hdc, pincel2);
                 region = CreateRectRgn(100,100,300,300);
                 SelectClipRgn(hdc, region);
                 SelectObject(hdc, pluma1);
                 for(x=0; x < 400; x+=5) {
                    MoveToEx(hdc, x, 0, NULL);
                    LineTo(hdc, 400-x, 400);
                    MoveToEx(hdc, 0, x, NULL);
                    LineTo(hdc, 400, 400-x);
                 }
                 DeleteObject(region);
                 ReleaseDC(hwnd, hdc);
                 break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(pincel1);
           DeleteObject(pincel2);
           DeleteObject(pluma1);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

int Alea(int min, int max) {
   int valores = max - min;

   return min + valores*rand()/(RAND_MAX+1);
}

