#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include "win028.h"

const double pi = 3.141592;

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "Icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "Icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground = GetStockObject(WHITE_BRUSH); //GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 028",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           500,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static HPEN pluma[4];
    static XFORM xform[7] = {
       {1, 0, 0, 1, 0, 0}, // Sin transformar (matriz identidad)
       {1.5, 0, 0, 1.5, 0, 0}, // Escalar
       {1, 0, 0, 1, 30, 30}, // Trasladar
       {1, 0, 0, 1, 0, 0}, // Rotal 45
       {1, 0, 0.5, 1, 0, 0},  // Desplazar eje
       {1, 0, 0, -1, 0, 0} // Reflejar
    };
    static int modo;
    RECT re;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           xform[3].eM11=cos(pi/4);
           xform[3].eM12=sin(pi/4);
           xform[3].eM21=-sin(pi/4);
           xform[3].eM22=cos(pi/4);
           pluma[0] = CreatePen(PS_DASHDOT, 0, RGB(127,127,127));
           pluma[1] = CreatePen(PS_SOLID, 2, RGB(0,0,0));
           pluma[2] = CreatePen(PS_DOT, 0, RGB(64,64,64));
           pluma[3] = CreatePen(PS_SOLID, 2, RGB(255,0,0));
           modo = 0;
           break;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           SetGraphicsMode(hdc, GM_ADVANCED);
           GetClientRect(hwnd, &re);
           SetViewportOrgEx(hdc, re.right/2, re.bottom/2, NULL);
           SetWorldTransform(hdc, &xform[modo]);
           SelectObject(hdc, GetStockObject(HOLLOW_BRUSH));
           SelectObject(hdc, pluma[2]);
           MoveToEx(hdc, 0, 0, NULL);
           LineTo(hdc, 140, 140);
           MoveToEx(hdc, 0, 0, NULL);
           LineTo(hdc, 140, -140);
           SelectObject(hdc, pluma[1]);
           Arc(hdc, -150, -150, 150, 150, 130, -130, 130,130);
           Arc(hdc, -130, -130, 130, 130, 130, -130, 130,130);
           Arc(hdc, -110, -110, 110, 110, 130, -130, 130,130);
           Arc(hdc, -90, -90, 90, 90, 130, -130, 130,130);
           MoveToEx(hdc, 90*sin(pi/4), 90*cos(pi/4), NULL);
           LineTo(hdc, 110*sin(pi/4), 110*cos(pi/4));
           MoveToEx(hdc, 130*sin(pi/4), 130*cos(pi/4), NULL);
           LineTo(hdc, 150*sin(pi/4), 150*cos(pi/4));
           MoveToEx(hdc, 90*sin(pi/4), -90*cos(pi/4), NULL);
           LineTo(hdc, 110*sin(pi/4), -110*cos(pi/4));
           MoveToEx(hdc, 130*sin(pi/4), -130*cos(pi/4), NULL);
           LineTo(hdc, 150*sin(pi/4), -150*cos(pi/4));
           SelectObject(hdc, pluma[0]);
           MoveToEx(hdc, -180, 0, NULL);
           LineTo(hdc, 180, 0);
           MoveToEx(hdc, 0, -180, NULL);
           LineTo(hdc, 0, 180);
           SelectObject(hdc, pluma[3]);
           Rectangle(hdc, -180, -5, -160, 5);
           Rectangle(hdc, -5, -180, 5, -160);
           EndPaint(hwnd, &ps);
           break;
        case WM_SIZE:
           InvalidateRect(hwnd, NULL, TRUE);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_COMBINAR:
                 CombineTransform(&xform[6], &xform[1], &xform[3]);
              case CM_ORIGINAL:
              case CM_ESCALAR:
              case CM_TRASLADAR:
              case CM_ROTAR:
              case CM_DESPLAZAR:
              case CM_REFLEJAR:
                 modo = LOWORD(wParam)-CM_ORIGINAL;
                 InvalidateRect(hwnd, NULL, TRUE);
                 break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(pluma[0]);
           DeleteObject(pluma[1]);
           DeleteObject(pluma[2]);
           DeleteObject(pluma[3]);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

