#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include "win029.h"

const double pi=3.141592;

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "Icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "Icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground = GetStockObject(WHITE_BRUSH); //GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 029",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           500,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static HPEN pluma[4];
    static int modo;
    RECT re;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           pluma[0] = CreatePen(PS_DASHDOT, 0, RGB(127,127,127));
           pluma[1] = CreatePen(PS_SOLID, 2, RGB(0,0,0));
           pluma[2] = CreatePen(PS_DOT, 0, RGB(64,64,64));
           pluma[3] = CreatePen(PS_SOLID, 2, RGB(255,0,0));
           modo = 0; // Ingls alto
           break;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           SetGraphicsMode(hdc, GM_COMPATIBLE);
           switch(modo) {
               case 0: // Ingls alto
                  SetMapMode(hdc, MM_HIENGLISH);
                  SetArcDirection(hdc, AD_CLOCKWISE);
                  break;
               case 1: // Ingls bajo
                  SetMapMode(hdc, MM_LOENGLISH);
                  SetArcDirection(hdc, AD_CLOCKWISE);
                  break;
               case 2: // Mtrico alto
                  SetMapMode(hdc, MM_HIMETRIC);
                  SetArcDirection(hdc, AD_CLOCKWISE);
                  break;
               case 3: // Mtrico bajo
                  SetMapMode(hdc, MM_LOMETRIC);
                  SetArcDirection(hdc, AD_CLOCKWISE);
                  break;
               case 4: // Texto
                  SetMapMode(hdc, MM_TEXT);
                  SetArcDirection(hdc, AD_COUNTERCLOCKWISE);
                  break;
               case 5: // Twips
                  SetMapMode(hdc, MM_TWIPS);
                  SetArcDirection(hdc, AD_CLOCKWISE);
                  break;
               case 6: // Isotrpico
                  SetMapMode(hdc, MM_ISOTROPIC);
                  SetWindowExtEx(hdc, -3*GetDeviceCaps(hdc, HORZSIZE),
                                      -3*GetDeviceCaps(hdc, VERTSIZE), NULL);
                  SetViewportExtEx(hdc, GetDeviceCaps(hdc, HORZRES),
                                        GetDeviceCaps(hdc, VERTRES), NULL);
                  SetArcDirection(hdc, AD_COUNTERCLOCKWISE);
                  break;
               case 7: // No isotrpico
                  SetMapMode(hdc, MM_ANISOTROPIC);
                  SetWindowExtEx(hdc, 3*GetDeviceCaps(hdc, HORZSIZE),
                                     -4*GetDeviceCaps(hdc, VERTSIZE), NULL);
                  SetViewportExtEx(hdc, GetDeviceCaps(hdc, HORZRES),
                                        GetDeviceCaps(hdc, VERTRES), NULL);
                  SetArcDirection(hdc, AD_CLOCKWISE);
                  break;

           }
           GetClientRect(hwnd, &re);
           SetWindowOrgEx(hdc, 0, 0, NULL);
           SetViewportOrgEx(hdc, re.right/2, re.bottom/2, NULL);
           SelectObject(hdc, GetStockObject(HOLLOW_BRUSH));
           SelectObject(hdc, pluma[2]);
           MoveToEx(hdc, 0, 0, NULL);
           LineTo(hdc, 140, 140);
           MoveToEx(hdc, 0, 0, NULL);
           LineTo(hdc, 140, -140);
           SelectObject(hdc, pluma[1]);
           Arc(hdc, -150, -150, 150, 150, 130, -130, 130,130);
           Arc(hdc, -130, -130, 130, 130, 130, -130, 130,130);
           Arc(hdc, -110, -110, 110, 110, 130, -130, 130,130);
           Arc(hdc, -90, -90, 90, 90, 130, -130, 130,130);
           MoveToEx(hdc, 90*sin(pi/4), 90*cos(pi/4), NULL);
           LineTo(hdc, 110*sin(pi/4), 110*cos(pi/4));
           MoveToEx(hdc, 130*sin(pi/4), 130*cos(pi/4), NULL);
           LineTo(hdc, 150*sin(pi/4), 150*cos(pi/4));
           MoveToEx(hdc, 90*sin(pi/4), -90*cos(pi/4), NULL);
           LineTo(hdc, 110*sin(pi/4), -110*cos(pi/4));
           MoveToEx(hdc, 130*sin(pi/4), -130*cos(pi/4), NULL);
           LineTo(hdc, 150*sin(pi/4), -150*cos(pi/4));
           SelectObject(hdc, pluma[0]);
           MoveToEx(hdc, -180, 0, NULL);
           LineTo(hdc, 180, 0);
           MoveToEx(hdc, 0, -180, NULL);
           LineTo(hdc, 0, 180);
           SelectObject(hdc, pluma[3]);
           Rectangle(hdc, -180, -5, -160, 5);
           Rectangle(hdc, -5, -180, 5, -160);
           EndPaint(hwnd, &ps);
           break;
        case WM_SIZE:
           InvalidateRect(hwnd, NULL, TRUE);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_INGALTO:
              case CM_INGBAJO:
              case CM_METALTO:
              case CM_METBAJO:
              case CM_TEXTO:
              case CM_TWIPS:
              case CM_ISOTROP:
              case CM_NOISOTROP:
                 modo = LOWORD(wParam)-CM_INGALTO;
                 InvalidateRect(hwnd, NULL, TRUE);
                 break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(pluma[0]);
           DeleteObject(pluma[1]);
           DeleteObject(pluma[2]);
           DeleteObject(pluma[3]);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

