#include <windows.h>
#include <string.h>
#include "win033.h"

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "Icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "Icono");
    wincl.hCursor = NULL;
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;    /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;    /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_BACKGROUND); //GetStockObject(WHITE_BRUSH);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 033",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           450,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static HINSTANCE hInstance;
    static int actual;
    static LPCTSTR idCursor[] = {IDC_APPSTARTING, IDC_ARROW,
      IDC_CROSS, IDC_IBEAM, IDC_ICON, IDC_NO, IDC_SIZE, IDC_SIZEALL,
      IDC_SIZENESW, IDC_SIZENS, IDC_SIZENWSE, IDC_SIZEWE, IDC_UPARROW,
      IDC_WAIT};
    static int dentro;
    HCURSOR cursor;
    POINT punto;
    int i;
    RECT re;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           actual = 0;
           dentro = FALSE;
           break;
        case WM_KILLFOCUS:
           ClipCursor(NULL);
           break;
        case WM_MOVE:
        case WM_SIZE:
        case WM_SETFOCUS:
           GetWindowRect(hwnd, &re);
           ClipCursor(&re);
           break;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           cursor = LoadCursorFromFile("horse.ani");
           for(i = 0; i < 12; i++) {
              DrawIconEx(hdc, 10+34*i,50, cursor, 0,0, i, NULL, DI_NORMAL|DI_COMPAT);
              DrawIconEx(hdc, 10+34*i,90, cursor, 0,0, 12+i, NULL, DI_NORMAL|DI_COMPAT);
           }
           for(i = 0; i < 14; i++) {
              cursor = LoadCursor(NULL, idCursor[i]);
              DrawIconEx(hdc, 10+34*i,120, cursor, 0, 0, 0, NULL, DI_NORMAL|DI_COMPAT);
           }
           EndPaint(hwnd, &ps);
           break;
        case WM_COMMAND:
           SetClassLong(hwnd, GCL_HCURSOR, (LONG)NULL);
           switch(LOWORD(wParam)) {
              case CM_ICONO:
              case CM_ANIMADO:
              case CM_FLECHA:
              case CM_ESTANDAR:
                 actual = LOWORD(wParam)-CM_ICONO;
                 dentro = FALSE;
                 break;
              case CM_CLASE:
                 actual = 4;
                 SetClassLong(hwnd, GCL_HCURSOR,
                    (LONG)LoadCursorFromFile("horse.ani"));
                 break;
              case CM_MOVER1:
                 punto.x = 0;
                 punto.y = 0;
                 ClientToScreen(hwnd, &punto);
                 SetCursorPos(punto.x, punto.y);
                 break;
              case CM_MOVER2:
                 GetClientRect(hwnd, &re);
                 punto.x = re.right;
                 punto.y = re.bottom;
                 ClientToScreen(hwnd, &punto);
                 SetCursorPos(punto.x, punto.y);
                 break;
              case CM_MOVER3:
                 GetClientRect(hwnd, &re);
                 punto.x = re.right/2;
                 punto.y = re.bottom/2;
                 ClientToScreen(hwnd, &punto);
                 SetCursorPos(punto.x, punto.y);
                 break;
           }
           break;
        case WM_SETCURSOR:
           GetCursorPos(&punto);
           ScreenToClient(hwnd, &punto);
           GetClientRect(hwnd, &re);

           if(actual < 4 && PtInRect(&re, punto)){
              if(!dentro){
                 dentro = TRUE;
                 switch(actual) {
                    case 0: // icono
                      SetCursor(LoadImage(hInstance, "tajmahal",
                         IMAGE_ICON, 0, 0, LR_LOADREALSIZE));
                      break;
                    case 1: // animado
                      SetCursor(LoadCursorFromFile("hourglas.ani"));
                      break;
                    case 2: // flecha
                      SetCursor(LoadCursor(hInstance, "flecha3D"));
                      break;
                    case 3: // estndar
                      SetCursor(LoadCursor(NULL, IDC_WAIT));
                      break;
                 }
              }
           }
           else {
              dentro = FALSE;
              return DefWindowProc(hwnd, msg, wParam, lParam);
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}


