#include <windows.h>
#include <stdio.h>
#include "win034.h"

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
void Pintar(HDC hdc, int izq, int cen, int der, POINTS punto, BOOL cli);
void MostrarHitTest(HDC hdc, LRESULT hittest);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "peque");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;    /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;    /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_BACKGROUND); //GetStockObject(WHITE_BRUSH);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 034",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           450,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static int izq, cen, der;
    short int rueda;
    static POINTS punto;
    static POINTS puntoHT;
    static LRESULT hittest;
    char cad[45];
    TRACKMOUSEEVENT tme;
    static BOOL dentro;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           izq=cen=der=0;
           dentro = FALSE;
           break;
        case WM_MOUSELEAVE:
           dentro = FALSE;
           hdc = GetDC(hwnd);
           TextOut(hdc, 10, 170, "Leave", 5);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_MOUSEHOVER:
           hdc = GetDC(hwnd);
           TextOut(hdc, 10, 170, "Hover", 5);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_MOUSEMOVE:
           punto = MAKEPOINTS(lParam);
           izq = (wParam & MK_LBUTTON) ? 1 : 0;
           cen = (wParam & MK_MBUTTON) ? 1 : 0;
           der = (wParam & MK_RBUTTON) ? 1 : 0;
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_LBUTTONDOWN:
           izq = 2;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_MBUTTONDOWN:
           cen = 2;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_RBUTTONDOWN:
           der = 2;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_LBUTTONUP:
           izq = 3;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_MBUTTONUP:
           cen = 3;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_RBUTTONUP:
           der = 3;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_LBUTTONDBLCLK:
           izq = 4;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_MBUTTONDBLCLK:
           cen = 4;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_RBUTTONDBLCLK:
           der = 4;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_NCMOUSEMOVE:
           punto = MAKEPOINTS(lParam);
           izq = 0;
           cen = 0;
           der = 0;
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           break;
        case WM_NCLBUTTONDOWN:
           izq = 2;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCMBUTTONDOWN:
           cen = 2;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCRBUTTONDOWN:
           der = 2;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCLBUTTONUP:
           izq = 3;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCMBUTTONUP:
           cen = 3;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCRBUTTONUP:
           der = 3;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCLBUTTONDBLCLK:
           izq = 4;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCMBUTTONDBLCLK:
           cen = 4;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_NCRBUTTONDBLCLK:
           der = 4;
           punto = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           ReleaseDC(hwnd, hdc);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           Pintar(hdc, izq, cen, der, punto, FALSE);
           MostrarHitTest(hdc, hittest);
           sprintf(cad, "Nmero de botones: %d", GetSystemMetrics(SM_CMOUSEBUTTONS));
           TextOut(hdc, 10, 50, cad, strlen(cad));
           sprintf(cad, "Punto HIT-TEST: (%4d, %4d)",
              puntoHT.x, puntoHT.y);
           TextOut(hdc, 10, 110, cad, strlen(cad));
           EndPaint(hwnd, &ps);
           break;
        case WM_NCHITTEST:
           puntoHT = MAKEPOINTS(lParam);
           hdc = GetDC(hwnd);
           sprintf(cad, "Punto HIT-TEST: (%4d, %4d)",
              puntoHT.x, puntoHT.y);
           TextOut(hdc, 10, 110, cad, strlen(cad));
           hittest = DefWindowProc(hwnd, msg, wParam, lParam);
           MostrarHitTest(hdc, hittest);
           if(HTCLIENT == hittest) {
              if(!dentro) {
                 dentro = TRUE;
                 TextOut(hdc, 10, 170, "------", 6);
                 tme.cbSize = sizeof(TRACKMOUSEEVENT);
                 tme.dwFlags = TME_HOVER | TME_LEAVE;
                 tme.hwndTrack = hwnd;
                 tme.dwHoverTime = 1000;
                 TrackMouseEvent(&tme);
              }
           }
           ReleaseDC(hwnd, hdc);
           return hittest;
           break;
        case WM_MOUSEACTIVATE:
           MessageBox(hwnd, "activate", "activate", MB_OK);
           return DefWindowProc(hwnd, msg, wParam, lParam);
           break;
        case WM_MOUSEWHEEL:
           punto = MAKEPOINTS(lParam);
           izq = (LOWORD(wParam) & MK_LBUTTON) ? 1 : 0;
           cen = (LOWORD(wParam) & MK_MBUTTON) ? 1 : 0;
           der = (LOWORD(wParam) & MK_RBUTTON) ? 1 : 0;
           rueda = HIWORD(wParam);
           rueda /= WHEEL_DELTA;
           hdc = GetDC(hwnd);
           Pintar(hdc, izq, cen, der, punto, TRUE);
           sprintf(cad, "rueda = %+04d ", rueda);
           TextOut(hdc, 10, 130, cad, strlen(cad));
           ReleaseDC(hwnd, hdc);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_CAPTURAR:
                 SetCapture(hwnd);
                 break;
              case CM_LIBERAR:
                 ReleaseCapture();
                 break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

void Pintar(HDC hdc, int izq, int cen, int der, POINTS punto, BOOL cli) {
   char cad[32];
   HBRUSH pincel[5];

   pincel[0] = CreateSolidBrush(RGB(255,255,255));
   pincel[1] = CreateSolidBrush(RGB(255,0,0));
   pincel[2] = CreateSolidBrush(RGB(255,255,0));
   pincel[3] = CreateSolidBrush(RGB(0,0,0));
   pincel[4] = CreateSolidBrush(RGB(255,0,255));
   SetBkColor(hdc, RGB(255,255,120));
   SelectObject(hdc, pincel[izq]);
   Rectangle(hdc, 100, 10, 120,30);
   SelectObject(hdc, pincel[cen]);
   Rectangle(hdc, 130, 10, 150,30);
   SelectObject(hdc, pincel[der]);
   Rectangle(hdc, 160, 10, 180,30);
   if(cli) {
      sprintf(cad, "x = %04d", punto.x);
      TextOut(hdc, 10, 10, cad, strlen(cad));
      sprintf(cad, "y = %04d", punto.y);
      TextOut(hdc, 10, 30, cad, strlen(cad));
   }
   else {
      sprintf(cad, "x = %04d", punto.x);
      TextOut(hdc, 10, 70, cad, strlen(cad));
      sprintf(cad, "y = %04d", punto.y);
      TextOut(hdc, 10, 90, cad, strlen(cad));
   }
   DeleteObject(pincel[0]);
   DeleteObject(pincel[1]);
   DeleteObject(pincel[2]);
   DeleteObject(pincel[3]);
   DeleteObject(pincel[4]);
}

void MostrarHitTest(HDC hdc, LRESULT hittest) {
   char cad[128];

   switch(hittest) {
      case HTCLIENT:
         strcpy(cad, "rea de cliente");
         break;
      case HTBORDER:
         strcpy(cad, "Borde");
         break;
      case HTBOTTOM:
         strcpy(cad, "Borde horizontal inferior");
         break;
      case HTBOTTOMLEFT:
         strcpy(cad, "Esquina inferior izquierda del borde");
         break;
      case HTBOTTOMRIGHT:
         strcpy(cad, "Esquina inferior derecha del borde");
         break;
      case HTCAPTION:
         strcpy(cad, "Barra de ttulo");
         break;
      case HTCLOSE:
         strcpy(cad, "Botn de cerrar");
         break;
      case HTERROR:
         strcpy(cad, "Fondo de pantalla o divisin entre ventanas");
         break;
      case HTGROWBOX:
         strcpy(cad, "Caja de cambio de tamao");
         break;
//      case HTSIZE:
//         strcpy(cad, "In a size box (same as HTGROWBOX)");
//         break;
      case HTHELP:
         strcpy(cad, "Botn de ayuda");
         break;
      case HTHSCROLL:
         strcpy(cad, "Barra de desplazamiento horizontal");
         break;
      case HTLEFT:
         strcpy(cad, "Borde izquierdo de una ventana");
         break;
      case HTMENU:
         strcpy(cad, "Barra de men");
         break;
      case HTMAXBUTTON:
         strcpy(cad, "Born de maximizar");
         break;
//      case HTZOOM:
//         strcpy(cad, "In a Maximize button");
//         break;
      case HTMINBUTTON:
         strcpy(cad, "Born de minimizar");
         break;
//      case HTREDUCE:
//         strcpy(cad, "In a Minimize button");
//         break;
      case HTNOWHERE:
         strcpy(cad, "En fondo de pantalla o lnea entre ventanas");
         break;
      case HTRIGHT:
         strcpy(cad, "Borde derecho de ventana");
         break;
      case HTSYSMENU:
         strcpy(cad, "Men de sistema o botn de cerrar ventana hija");
         break;
      case HTTOP:
         strcpy(cad, "Borde horizontal superior");
         break;
      case HTTOPLEFT:
         strcpy(cad, "Esquina superior izquierda de borde de ventana");
         break;
      case HTTOPRIGHT:
         strcpy(cad, "Esquina superior derecha de borde de ventana");
         break;
      case HTTRANSPARENT:
         strcpy(cad, "Ventana cubierta actualmente por otra ventana");
         break;
      case HTVSCROLL:
         strcpy(cad, "Barra de desplazamiento vertical");
         break;
      default:
         strcpy(cad, "?");
         break;
   }
   Rectangle(hdc,98,68,500,88);
   TextOut(hdc, 100, 70, cad, strlen(cad));
}
