#define _WIN32_WINNT 0x0500
#include <windows.h>
#include "win047.h"

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
void InsertarMenuOpciones(HINSTANCE, HWND, HBITMAP *);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */
    char titulo[64];

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "menu";
    wincl.cbClsExtra = 0;    /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;    /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_BACKGROUND); //GetStockObject(WHITE_BRUSH);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    LoadString(hThisInstance, ID_TITULO, titulo, 64);

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           titulo,              /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           450,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    MENUITEMINFO infoMenu;
    char mensaje[64];
    char titulo[64];
    char plantilla[64];
    static HBITMAP hSi;
    static HBITMAP hNo;
    int i;

    HBITMAP hBMOpcion[5];

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;

           // Insertar men de opciones con mapas de bits:
           InsertarMenuOpciones(hInstance, hwnd, hBMOpcion);

           hSi = LoadBitmap(hInstance, "si");
           hNo = LoadBitmap(hInstance, "no");

           infoMenu.cbSize = sizeof(MENUITEMINFO);
           infoMenu.fMask = MIIM_CHECKMARKS;
           infoMenu.hbmpChecked = hSi;
           infoMenu.hbmpUnchecked = hNo;
           for(i = 0; i < 3; i++)
//            SetMenuItemBitmaps(GetSubMenu(GetMenu(hwnd),0), i, MF_BYPOSITION, hSi, hNo);
              SetMenuItemInfo(GetSubMenu(GetMenu(hwnd),0), i, TRUE, &infoMenu);

           CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_ACTIVAR, MF_BYCOMMAND);

           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
             case CM_INHIBIR:
                EnableMenuItem(GetMenu(hwnd),CM_OPCION, MF_DISABLED | MF_BYCOMMAND);
                CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_INHIBIR, MF_BYCOMMAND);
                break;
             case CM_OSCURECER:
                EnableMenuItem(GetMenu(hwnd),CM_OPCION, MF_GRAYED | MF_BYCOMMAND);
                CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_OSCURECER, MF_BYCOMMAND);
                break;
             case CM_ACTIVAR:
                EnableMenuItem(GetMenu(hwnd),CM_OPCION, MF_ENABLED | MF_BYCOMMAND);
                CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_ACTIVAR, MF_BYCOMMAND);
                break;
             default:
                LoadString(hInstance, ID_TITULO, titulo, 64);
                LoadString(hInstance, ID_MENSAJE, plantilla, 64);
                wsprintf(mensaje, plantilla, LOWORD(wParam)-CM_OPCION);
                MessageBox(hwnd, mensaje, titulo, MB_OK);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hNo);
           DeleteObject(hSi);
           for(i = 0; i < 5; i++) DeleteObject(hBMOpcion[i]);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

void InsertarMenuOpciones(HINSTANCE hInstance, HWND hwnd, HBITMAP *hBMOpcion)
{
    HBITMAP hBitmap;
    HBITMAP hBMv1, hBMv2;
    HBRUSH pluma, hpant;
    HFONT hfont;
    HDC memDC;
    HDC memDCdest;
    HDC hDC;

    HMENU hmenu;

    char plantilla[64];
    char nombre[64];
    int i;

    // Crear un men popup de opciones:
    hmenu = CreatePopupMenu();

    hDC = GetDC(hwnd);
    memDC = CreateCompatibleDC(hDC);
    memDCdest = CreateCompatibleDC(hDC);
    pluma = CreateSolidBrush(GetSysColor(COLOR_MENU));
    hpant = SelectObject(memDC, pluma);

    // Seleccionar una fuente de ancho proporcional:
    hfont = SelectObject(memDC, GetStockObject(ANSI_VAR_FONT));
    // Y el modo transparente:
    SetBkMode(memDC, TRANSPARENT);

    // Crear mapas de bits a partir de recursos y texto aadido:
    for(i = 0; i < 5; i++) {
       // Crear mapas de bits:
       hBMOpcion[i] = CreateCompatibleBitmap(hDC, 100, 48);

       // Cargar mapas de bits de opciones de 48x48 px:
       wsprintf(nombre, "opcion%1d", i+1);
       hBitmap = LoadBitmap(hInstance, nombre);

       // Seleccionar el mapa de bits que vamos a crear:
       hBMv1 = SelectObject(memDC, hBMOpcion[i]);
       // Fondo de color de men:
       ExtFloodFill(memDC, 0, 0, GetSysColor(COLOR_MENU), FLOODFILLBORDER);

       // Seleccionar el mapa de bits de recurso en otro DC:
       hBMv2 = SelectObject(memDCdest, hBitmap);
       // Para copiarlo al nuestro:
       BitBlt(memDC, 0, 0, 48, 48, memDCdest, 0, 0, SRCCOPY);

       // Ya no lo necesitamos ms:
       DeleteObject(hBitmap);
       // Ni tampoco el DC de destino:
       SelectObject(memDCdest, hBMv2);

       // Aadir texto:
       LoadString(hInstance, ID_ITEMOPCION, plantilla, 64);
       wsprintf(nombre, plantilla, i+1);

       TextOut(memDC, 54, 20, nombre, lstrlen(nombre));

//       infoMenu.cbSize = sizeof(MENUITEMINFO);
//       infoMenu.fMask = MIIM_TYPE | MIIM_ID;
//       infoMenu.fType = MFT_BITMAP;
//       infoMenu.wID = CM_OPCION+i+1;
//       infoMenu.dwTypeData = (LPSTR) (hBMOpcion[i]);
//       InsertMenuItem(hmenu, i, TRUE, &infoMenu);
       InsertMenu(hmenu, i, MF_BYPOSITION | MF_BITMAP, CM_OPCION+1+i, (LPCTSTR)(hBMOpcion[i]));
       SelectObject(memDC, hBMv1);
    }

    // Seleccionar pluma original:
    SelectObject(memDC, hpant);
    // Seleccionar fuente previa:
    SelectObject(memDC, hfont);
    // Borrar los DC de memoria:
    DeleteObject(memDC);
    DeleteDC(memDCdest);
    // Liberar el DC compatible:
    ReleaseDC(hwnd, hDC);

    // Aadir el men popup en la segunda conlumna:
    AppendMenu(GetMenu(hwnd), MF_STRING | MF_POPUP, (UINT) hmenu, "Mapas de &bits");
}

