#include <windows.h>
#include <stdio.h>
#include "win057.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

char *cadena[22] =
   {
      "Argentina",
      "Mexico",
      "Brasil",
      "Peru",
      "Colombia",
      "Bolivia",
      "Venezuela",
      "Chile",
      "Espaa",
      "Paraguay",
      "Ecuador",
      "Uruguay",
      "Nicaragua",
      "Honduras",
      "Cuba",
      "Guatemala",
      "Portugal",
      "Panam",
      "Costa Rica",
      "Repblica Dominicana",
      "El Salvador",
      "Puerto Rico"
   };

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 057",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    HFONT hfont;
    static HWND hctrl;
    int i;
    char cad[128];
    HDC hdc;
    PAINTSTRUCT ps;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           /* Insertar control Edit */
           hctrl = CreateWindowEx(
              0,
              "LISTBOX",       /* Nombre de la clase */
              "",              /* Texto del ttulo, no tiene */
              LBS_STANDARD | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              9, 19,           /* Posicin */
              144, 120,        /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_LISTA, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           /* Inicializacin de los datos de la aplicacin */
           for(i = 0; i < 22; i++)
              SendMessage(hctrl, LB_ADDSTRING, 0, (LPARAM)cadena[i]);
           SendMessage(hctrl, LB_SETCURSEL, (WPARAM)0, 0);
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SetFocus(hctrl);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case ID_LISTA:
                 switch(HIWORD(wParam)) {
                   case LBN_SELCHANGE:
                      InvalidateRect(hwnd, NULL, TRUE);
                      break;
                 }
                 break;
              case CM_ANEXAR:
                sprintf(cad, "NUEVA CADENA");
                SendMessage(hctrl, LB_ADDSTRING, 0, (LPARAM)cad);
                break;
              case CM_SELECT:
                i = SendMessage(hctrl, LB_GETCURSEL, 0, 0);
                SendMessage(hctrl, LB_SELECTSTRING, (WPARAM)i, (LPARAM)"E");
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_DELETE:
                i = SendMessage(hctrl, LB_GETCURSEL, 0, 0);
                SendMessage(hctrl, LB_DELETESTRING, (WPARAM)i, 0);
                break;
              case CM_BUSCAR:
                i = SendMessage(hctrl, LB_GETCURSEL, 0, 0);
                i = SendMessage(hctrl, LB_FINDSTRING, (WPARAM)i, (LPARAM)"CO");
                SendMessage(hctrl, LB_SETCURSEL, (WPARAM)i, 0);
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_EXACTA:
                i = SendMessage(hctrl, LB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)"Portugal");
                SendMessage(hctrl, LB_SETCURSEL, (WPARAM)i, 0);
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_CONTADOR:
                i = SendMessage(hctrl, LB_GETCOUNT, 0, 0);
                sprintf(cad, "Nmero de tems: %d", i);
                MessageBox(hwnd, cad, "Ejemplo 57", MB_OK);
                break;
              case CM_PRIMERITEM:
                i = SendMessage(hctrl, LB_GETTOPINDEX, 0, 0);
                sprintf(cad, "Pimer tem visible: %d", i);
                MessageBox(hwnd, cad, "Ejemplo 57", MB_OK);
                break;
              case CM_INSERTAR:
                sprintf(cad, "CADENA INSERTADA");
                i = SendMessage(hctrl, LB_GETCURSEL, 0, 0);
                SendMessage(hctrl, LB_INSERTSTRING, (WPARAM)i, (LPARAM)cad);
                break;
              case CM_VACIAR:
                SendMessage(hctrl, LB_RESETCONTENT, 0, 0);
                break;
              case CM_SETCUR:
                i = SendMessage(hctrl, LB_GETCURSEL, 0, 0);
                SendMessage(hctrl, LB_SETCURSEL, (WPARAM)i+1, 0);
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_NUEVOPRIMERO:
                SendMessage(hctrl, LB_SETTOPINDEX, (WPARAM)18, 0);
                break;
              case CM_INICIAR:
                for(i = 0; i < 22; i++)
                SendMessage(hctrl, LB_ADDSTRING, 0, (LPARAM)cadena[i]);
                break;
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_PAINT:
           i = SendMessage(hctrl, LB_GETCURSEL, 0, 0);
           hdc = BeginPaint(hwnd, &ps);
           SetBkMode(hdc, TRANSPARENT);
           sprintf(cad, "Sel: %d", i);
           TextOut(hdc, 300, 20, cad, strlen(cad));
           SendMessage(hctrl, LB_GETTEXT, (WPARAM)i, (LPARAM)cad);
           TextOut(hdc, 300, 40, cad, strlen(cad));
           EndPaint(hwnd, &ps);
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
