#include <windows.h>

#include "win060.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

char *cadena[22] =
   {
      "Argentina",
      "Mexico",
      "Brasil",
      "Peru",
      "Colombia",
      "Bolivia",
      "Venezuela",
      "Chile",
      "Espaa",
      "Paraguay",
      "Ecuador",
      "Uruguay",
      "Nicaragua",
      "Honduras",
      "Cuba",
      "Guatemala",
      "Portugal",
      "Panam",
      "Costa Rica",
      "Repblica Dominicana",
      "El Salvador",
      "Puerto Rico"
   };

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 060",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           470,                 /* Ancho */
           300,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    HFONT hfont;
    static HWND hlista1, hlista2;
    HWND hboton1, hboton2;
    int i, n, nSeleccionados;
    int *seleccionado;
    char cad[512];

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           /* Insertar control Edit */
           hlista1 = CreateWindowEx(
              0,
              "LISTBOX",       /* Nombre de la clase */
              "",              /* Texto del ttulo, no tiene */
              LBS_MULTIPLESEL | LBS_STANDARD | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              9, 4,           /* Posicin */
              220, 220,        /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_LISTA1,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hlista2 = CreateWindow(
              "LISTBOX",       /* Nombre de la clase */
              "",              /* Texto del ttulo, no tiene */
              LBS_EXTENDEDSEL | LBS_STANDARD | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              230, 4,           /* Posicin */
              220, 220,        /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_LISTA2,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hboton1 = CreateWindow(
              "BUTTON",        /* Nombre de la clase */
              "Pasar >>",      /* Texto del ttulo, no tiene */
              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              30, 220,         /* Posicin */
              60, 30,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_BOTON1,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hboton2 = CreateWindow(
              "BUTTON",        /* Nombre de la clase */
              "<< Pasar",      /* Texto del ttulo, no tiene */
              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              360, 220,         /* Posicin */
              60, 30,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_BOTON2,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */

           /* Inicializacin de los datos de la aplicacin */
           for(i = 0; i < 22; i++) {
              SendMessage(GetDlgItem(hwnd, ID_LISTA1), LB_ADDSTRING,
                 0, (LPARAM)cadena[i]);
           }
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           SendMessage(hlista1, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SendMessage(hlista2, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SendMessage(hboton1, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SendMessage(hboton2, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case ID_LISTA1:
                 switch(HIWORD(wParam)) {
                 }
                 break;
              case ID_BOTON1:
                nSeleccionados = SendMessage(hlista1, LB_GETSELCOUNT,
                   0, 0);
                seleccionado = (int *)malloc(nSeleccionados*sizeof(int));
                SendMessage(hlista1, LB_GETSELITEMS,
                   (WPARAM)nSeleccionados, (LPARAM)seleccionado);
                for(i = nSeleccionados-1; i >= 0; i--) {
                   SendMessage(hlista1, LB_GETTEXT,
                      (WPARAM)seleccionado[i], (LPARAM)cad);
                   SendMessage(hlista2, LB_ADDSTRING,
                      0, (LPARAM)cad);
                   SendMessage(hlista1, LB_DELETESTRING,
                      (WPARAM)seleccionado[i], 0);
                }
                free(seleccionado);
                break;
              case ID_BOTON2:
                nSeleccionados = SendMessage(hlista2, LB_GETSELCOUNT,
                   0, 0);
                seleccionado = (int *)malloc(nSeleccionados*sizeof(int));
                SendMessage(hlista2, LB_GETSELITEMS,
                   (WPARAM)nSeleccionados, (LPARAM)seleccionado);
                for(i = nSeleccionados-1; i >= 0; i--) {
                   SendMessage(hlista2, LB_GETTEXT,
                      (WPARAM)seleccionado[i], (LPARAM)cad);
                   SendMessage(hlista1, LB_ADDSTRING,
                      0, (LPARAM)cad);
                   SendMessage(hlista2, LB_DELETESTRING,
                      (WPARAM)seleccionado[i], 0);
                }
                free(seleccionado);
                break;
              case CM_LISTASEL:
                n = SendMessage(hlista1, LB_GETCOUNT, 0, 0);
                for(i = 0; i < n; i++) {
                   if(SendMessage(hlista1, LB_GETSEL, (WPARAM)i, 0)) {
                      SendMessage(hlista1, LB_GETTEXT,
                         (WPARAM)i, (LPARAM)cad);
                      MessageBox(hwnd, cad, "tem seleccionado", MB_OK);
                   }
                }
                break;
              case CM_SELPAR:
                n = SendMessage(hlista1, LB_GETCOUNT, 0, 0);
                for(i = 0; i < n; i++) {
                   SendMessage(hlista1, LB_SETSEL, (WPARAM)i%2, (LPARAM)i);
                }
                break;
              case CM_ANCLA:
                i = SendMessage(hlista2, LB_GETANCHORINDEX, 0, 0);
                SendMessage(hlista2, LB_GETTEXT,
                         (WPARAM)i, (LPARAM)cad);
                MessageBox(hwnd, cad, "tem ancla", MB_OK);
                break;
              case CM_CARET:
                i = SendMessage(hlista2, LB_GETCARETINDEX, 0, 0);
                SendMessage(hlista2, LB_GETTEXT,
                         (WPARAM)i, (LPARAM)cad);
                MessageBox(hwnd, cad, "tem caret", MB_OK);
                break;
              case CM_SELTODO1:
                n = SendMessage(hlista1, LB_GETCOUNT, 0, 0);
                SendMessage(hlista1, LB_SELITEMRANGE,
                   (WPARAM)TRUE, MAKELPARAM(0, n));
                break;
              case CM_SELTODO2:
                n = SendMessage(hlista2, LB_GETCOUNT, 0, 0);
                SendMessage(hlista2, LB_SELITEMRANGEEX,
                   (WPARAM)0, (LPARAM)n);
                break;
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
