#include <windows.h>

#include "win067.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void IniciarPaises(HWND hctrl);
void IniciarPlanetas(HWND hctrl);

struct Pais {
   char *Nombre;
   char *Capital;
   int Superficie;
} paises[22] =
   {
      {"Argentina", "Buenos Aires", 2766890},
      {"Mexico", "Mexico DC", 1972550},
      {"Brasil", "Brasilia", 8514876},
      {"Peru", "Lima", 1285220},
      {"Colombia", "Bogot", 1138910},
      {"Bolivia", "La Paz", 1098580},
      {"Venezuela", "Caracas", 912050},
      {"Chile", "Santiago", 756096},
      {"Espaa", "Madrid", 504782},
      {"Paraguay", "Asuncin", 406750},
      {"Ecuador", "Quito", 283560},
      {"Uruguay", "Montevideo", 176220},
      {"Nicaragua", "Managua", 129494},
      {"Honduras", "Tegucigalpa", 112090},
      {"Cuba", "La Habana", 110860},
      {"Guatemala", "Guatemala", 108890},
      {"Portugal", "Lisboa", 92391},
      {"Panam", "Panam", 78200},
      {"Costa Rica", "San Jos", 51100},
      {"Repblica Dominicana", "Santo Domingo", 48730},
      {"El Salvador", "San Salvador", 21040},
      {"Puerto Rico", "San Juan", 9104}
   };

struct Planeta {
   char *Nombre;
} planetas[9] =
   {
      {"Mercurio"}, {"Venus"}, {"Tierra"}, {"Marte"}, {"Jupiter"},
      {"Saturno"}, {"Urano"}, {"Neptuno"}, {"Plutn"}
   };

HBITMAP bandera[22];
HBITMAP planeta[9];

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 067",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           600,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    /* Variables para dilogo */
    static HFONT hfont;
    HWND hctrl;
    MEASUREITEMSTRUCT *lpmis;
    DRAWITEMSTRUCT *lpdis;
    TEXTMETRIC tm;
    HBITMAP hbmpOld;
    HDC hdcMem;
    char tchBuffer[64];
    int i, y;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           hfont = CreateFont(20, 0, 0, 0, 300,
              FALSE, FALSE, FALSE, DEFAULT_CHARSET,
              OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
              PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN,
              "Times New Roman");
           /* Insertar controles */
           hctrl = CreateWindowEx(
              0,
              "LISTBOX",       /* Nombre de la clase */
              "",              /* Texto del ttulo */
              LBS_HASSTRINGS | LBS_STANDARD | LBS_OWNERDRAWVARIABLE |
              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              9, 19,           /* Posicin */
              280, 280,        /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_LISTA1,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           IniciarPaises(hctrl);
           for(i = 0; i < 22; i++)
              bandera[i] = LoadBitmap(hInstance, MAKEINTRESOURCE(BM_BANDERA+i));
           SendMessage(hctrl, LB_SETCURSEL, (WPARAM)0, 0);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SetFocus(hctrl);
           hctrl = CreateWindowEx(
              0,
              "LISTBOX",       /* Nombre de la clase */
              "",              /* Texto del ttulo */
              LBS_STANDARD | LBS_OWNERDRAWVARIABLE |
              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              300, 19,         /* Posicin */
              280, 280,        /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_LISTA2,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           IniciarPlanetas(hctrl);
           for(i = 0; i < 9; i++)
              planeta[i] = LoadBitmap(hInstance, MAKEINTRESOURCE(BM_PLANETA+i));
           SendMessage(hctrl, LB_SETCURSEL, (WPARAM)0, 0);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           return 0;
        case WM_MEASUREITEM:
            lpmis = (LPMEASUREITEMSTRUCT) lParam;
            /* Ajustar la altura de los tems. */
            if(lpmis->CtlID == ID_LISTA1) lpmis->itemHeight = 32;
            else lpmis->itemHeight = 60;
            return TRUE;
        case WM_DRAWITEM:
           lpdis = (LPDRAWITEMSTRUCT) lParam;
           switch(lpdis->CtlID) {
              case ID_LISTA1:
                switch (lpdis->itemAction) {
                  case ODA_SELECT:
                  case ODA_DRAWENTIRE:
                  case ODA_FOCUS:
                    /* Borrar el contenido previo */
                    FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH)(COLOR_WINDOW+1));
                    SendMessage(lpdis->hwndItem, LB_GETTEXT,
                       lpdis->itemID, (LPARAM) tchBuffer);
                    GetTextMetrics(lpdis->hDC, &tm);
                    y = (lpdis->rcItem.bottom + lpdis->rcItem.top -
                       tm.tmHeight) / 2;
                    i = SendMessage(lpdis->hwndItem, LB_GETITEMDATA, (WPARAM)lpdis->itemID, 0);
                    if(paises[i].Superficie > 92391)
                       SetTextColor(lpdis->hDC, RGB(0,128,0));
                    else
                       SetTextColor(lpdis->hDC, RGB(0,0,255));
                    hdcMem = CreateCompatibleDC(lpdis->hDC);
                    hbmpOld = SelectObject(hdcMem, bandera[i]);
                    BitBlt(lpdis->hDC,
                      lpdis->rcItem.left, lpdis->rcItem.top,
                      lpdis->rcItem.right - lpdis->rcItem.left,
                      lpdis->rcItem.bottom - lpdis->rcItem.top,
                      hdcMem, 0, 0, SRCCOPY);
                    TextOut(lpdis->hDC, 90, y, tchBuffer, strlen(tchBuffer));
                    SelectObject(hdcMem, hbmpOld);
                    DeleteDC(hdcMem);
                    if (lpdis->itemState & ODS_SELECTED) {
                      SetTextColor(lpdis->hDC, RGB(0,0,0));
                      DrawFocusRect(lpdis->hDC, &lpdis->rcItem);
                    }
                }
                break;
              case ID_LISTA2:
                switch (lpdis->itemAction) {
                  case ODA_SELECT:
                  case ODA_DRAWENTIRE:
                  case ODA_FOCUS:
                    /* Borrar el contenido previo */
                    FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH)(COLOR_WINDOW+1));
                    GetTextMetrics(lpdis->hDC, &tm);
                    y = (lpdis->rcItem.bottom + lpdis->rcItem.top -
                       tm.tmHeight) / 2;
                    hdcMem = CreateCompatibleDC(lpdis->hDC);
                    hbmpOld = SelectObject(hdcMem, planeta[lpdis->itemData]);
                    BitBlt(lpdis->hDC,
                      lpdis->rcItem.left, lpdis->rcItem.top,
                      lpdis->rcItem.right - lpdis->rcItem.left,
                      lpdis->rcItem.bottom - lpdis->rcItem.top,
                      hdcMem, 0, 0, SRCCOPY);
                    TextOut(lpdis->hDC, 70, y,
                       planetas[lpdis->itemData].Nombre,
                       strlen(planetas[lpdis->itemData].Nombre));
                    SelectObject(hdcMem, hbmpOld);
                    DeleteDC(hdcMem);
                    if(lpdis->itemState & ODS_SELECTED) {
                      SetTextColor(lpdis->hDC, RGB(0,0,0));
                      DrawFocusRect(lpdis->hDC, &lpdis->rcItem);
                    }
                }
                break;
           }
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           for(i = 0; i < 22; i++) DeleteObject(bandera[i]);
           for(i = 0; i < 9; i++) DeleteObject(planeta[i]);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

void IniciarPaises(HWND hctrl)
{
   int i;
   int actual;

   for(i = 0; i < 22; i++) {
      actual = SendMessage(hctrl, LB_ADDSTRING, 0, (LPARAM)paises[i].Nombre);
      SendMessage(hctrl, LB_SETITEMDATA, (WPARAM)actual, i);
   }
}

void IniciarPlanetas(HWND hctrl)
{
   int i;

   for(i = 0; i < 9; i++)
      SendMessage(hctrl, LB_INSERTSTRING, i, (LPARAM)i);
}
