#include <windows.h>

#include "win070.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color gris de dilogo */
    wincl.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH); // GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 070",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hfont;
    static HBRUSH pincel;
    static UINT tipo;
    PAINTSTRUCT ps;
    HDC hdc;
    HWND hctrl;
    HICON Icono;
    HBITMAP bitmap;
    LPDRAWITEMSTRUCT lpdis;
    char cad[128];
    RECT re;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           tipo = BF_RECT;
           pincel = CreateSolidBrush(RGB(0,255,0));
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           hfont = CreateFont(20, 0, 0, 0, 300,
              FALSE, FALSE, FALSE, DEFAULT_CHARSET,
              OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
              PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN,
              "Times New Roman");
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_BLACKFRAME |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 5,            /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST1,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_GRAYFRAME |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              65, 5,           /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST2,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_WHITEFRAME |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              125, 5,          /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST3,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_BLACKRECT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 65,           /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST4,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_GRAYRECT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              65, 65,          /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST5,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_WHITERECT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              125, 65,         /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST6,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_ETCHEDHORZ |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 125,          /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST7,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_ETCHEDVERT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              65, 125,         /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST8,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo */
              SS_ETCHEDFRAME |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              125, 125,        /* Posicin */
              55, 55,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST9,  /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Ejemplo de texto para control esttico",       /* Texto del ttulo */
              SS_SIMPLE |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              185, 5,          /* Posicin */
              155, 55,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST10, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Ejemplo de texto para control esttico",       /* Texto del ttulo */
              SS_LEFT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              185, 65,         /* Posicin */
              155, 55,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST11, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Ejemplo de texto para control esttico",       /* Texto del ttulo */
              SS_CENTER |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              185, 125,        /* Posicin */
              155, 55,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST12, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Ejemplo de texto para control esttico",       /* Texto del ttulo */
              SS_RIGHT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              185, 185,        /* Posicin */
              155, 55,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST13, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "&Ejemplo de texto para control esttico",       /* Texto del ttulo */
              SS_LEFTNOWORDWRAP |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              185, 245,        /* Posicin */
              155, 55,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST14, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Power",         /* Texto del ttulo */
              SS_BITMAP |
              SS_RIGHTJUST |
              SS_SUNKEN |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              345, 5,          /* Posicin */
              150, 150,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST15, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           bitmap = LoadBitmap(hInstance,  MAKEINTRESOURCE(Power));
           SendMessage(hctrl, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)bitmap);
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Power",         /* Texto del ttulo */
              SS_ICON |
              SS_RIGHTJUST |
              SS_SUNKEN |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              345, 165,         /* Posicin */
              150, 150,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST16, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           Icono = LoadIcon(hInstance, MAKEINTRESOURCE(Icono2));
           SendMessage(hctrl, STM_SETICON, (WPARAM)Icono, 0);
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Power",         /* Texto del ttulo */
              SS_ICON |
              SS_RIGHTJUST |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              345, 215,         /* Posicin */
              150, 150,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST17, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           Icono = LoadIcon(hInstance, MAKEINTRESOURCE(Icono2));
           SendMessage(hctrl, STM_SETICON, (WPARAM)Icono, 0);
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Texto",         /* Texto del ttulo */
              SS_OWNERDRAW |
              WS_CHILD | WS_VISIBLE, /* Estilo */
              455, 155,         /* Posicin */
              60, 20,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST18, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Inhibir",       /* Texto del ttulo */
              SS_CENTER |
              SS_NOTIFY |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              420, 185,        /* Posicin */
              85, 20,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST19, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Desinhibir",    /* Texto del ttulo */
              SS_CENTER |
              SS_NOTIFY |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              420, 220,        /* Posicin */
              85, 20,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST20, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "Modificar",     /* Texto del ttulo */
              SS_CENTER |
              SS_NOTIFY |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              420, 255,        /* Posicin */
              85, 20,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST21, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "EDIT",          /* Nombre de la clase */
              "Modificar",     /* Texto del ttulo */
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              420, 295,        /* Posicin */
              85, 20,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_EST21, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           return 0;
        case WM_CTLCOLORSTATIC:
           if((HWND)lParam == GetDlgItem(hwnd, ID_EST14)) {
             SetTextColor((HDC)wParam, RGB(0,0,255));
             SetBkColor((HDC)wParam, RGB(0,255,0));
             return (LRESULT)pincel;
           }
           break;
        case WM_DRAWITEM:
           lpdis = (LPDRAWITEMSTRUCT)lParam;
           SendDlgItemMessage(hwnd, (UINT)wParam, WM_GETTEXT, 128, (LPARAM)cad);
           GetClientRect(lpdis->hwndItem, &re);
           SetBkMode(lpdis->hDC, TRANSPARENT);
           FillRect(lpdis->hDC, &re, (HBRUSH)GetStockObject(LTGRAY_BRUSH));
           SelectObject(lpdis->hDC, (HBRUSH)GetStockObject(GRAY_BRUSH));
           SelectObject(lpdis->hDC, (HPEN)GetStockObject(WHITE_PEN));
           Ellipse(lpdis->hDC, re.left, re.top, re.right, re.bottom);
           TextOut(lpdis->hDC, re.left+12, re.top+2, cad, strlen(cad));
           return 0;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           re.left = 10; re.top = 200; re.right = 50; re.bottom = 240;
           DrawEdge(hdc, &re, EDGE_BUMP, tipo);
           re.left = 70; re.top = 200; re.right = 110; re.bottom = 240;
           DrawEdge(hdc, &re, EDGE_ETCHED, tipo);
           re.left = 10; re.top = 250; re.right = 50; re.bottom = 290;
           DrawEdge(hdc, &re, EDGE_RAISED, tipo);
           re.left = 70; re.top = 250; re.right = 110; re.bottom = 290;
           DrawEdge(hdc, &re, EDGE_SUNKEN, tipo);
           EndPaint(hwnd, &ps);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_BORDE:
                tipo = BF_ADJUST | BF_RECT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+1:
                tipo = BF_BOTTOM;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+2:
                tipo = BF_BOTTOMLEFT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+3:
                tipo = BF_BOTTOMRIGHT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+4:
                tipo = BF_DIAGONAL;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+5:
                tipo = BF_DIAGONAL_ENDBOTTOMLEFT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+6:
                tipo = BF_DIAGONAL_ENDBOTTOMRIGHT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+7:
                tipo = BF_DIAGONAL_ENDTOPLEFT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+8:
                tipo = BF_DIAGONAL_ENDTOPRIGHT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+9:
                tipo = BF_FLAT | BF_RECT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+10:
                tipo = BF_LEFT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+11:
                tipo = BF_MIDDLE | BF_RECT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+12:
                tipo = BF_MONO | BF_RECT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+13:
                tipo = BF_RECT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+14:
                tipo = BF_RIGHT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+15:
                tipo = BF_SOFT | BF_RECT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+16:
                tipo = BF_TOP;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+17:
                tipo = BF_TOPLEFT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_BORDE+18:
                tipo = BF_TOPRIGHT;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
              case ID_EST19:
                EnableWindow(GetDlgItem(hwnd, ID_EST21), FALSE);
                break;
              case ID_EST20:
                EnableWindow(GetDlgItem(hwnd, ID_EST21), TRUE);
                break;
              case ID_EST21:
                switch(HIWORD(wParam)) {
                   case STN_CLICKED:
                      SetWindowText(GetDlgItem(hwnd, ID_EST12), "Modificado");
                      SendDlgItemMessage(hwnd, ID_EST13, WM_SETTEXT, 0, (LPARAM)"Nuevo texto");
                      SendMessage(GetDlgItem(hwnd, ID_EST14), WM_SETTEXT, 0, (LPARAM)"Nuevo texto");
                      MoveWindow(GetDlgItem(hwnd, ID_EST15), 345, 5, 100, 100, TRUE);
                      MoveWindow(GetDlgItem(hwnd, ID_EST16), 345, 165, 10, 10, TRUE);
                      InvalidateRect(hwnd, NULL, TRUE);
                      break;
                   case STN_DBLCLK:
                      MessageBox(hwnd, "Doble clic", "Controles estticos", MB_OK);
                      break;
                   case STN_DISABLE:
                      MessageBox(hwnd, "Disable", "Controles estticos", MB_OK);
                      break;
                   case STN_ENABLE:
                      MessageBox(hwnd, "Enable", "Controles estticos", MB_OK);
                      break;
                }
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           DeleteObject(pincel);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
