#include <windows.h>
#include <stdio.h>
#include "win071.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 071",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    char* mes[] = {"Enero", "Febrero", "Marzo", "Abril", "Mayo",
      "Junio", "Julio", "Agosto", "Septiembre", "Octubre",
      "Noviembre", "Diciembre"};
    int i;

    static HINSTANCE hInstance;
    /* Variables para dilogo */
    static HFONT hfont;
    HWND hctrl;
    static HBRUSH pincel, pincel2;
    char cad[128];
    int y;
    HDC hdc;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "COMBOBOX",  /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              CBS_SIMPLE |
              WS_VSCROLL |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 5,            /* Posicin */
              120, 85,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_COMBO1,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           for(i = 0; i < 12; i++)
              SendMessage(hctrl, CB_ADDSTRING, 0, (LPARAM)mes[i]);
           SetFocus(hctrl);
           hctrl = CreateWindowEx(
              0,
              "COMBOBOX",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              CBS_UPPERCASE | CBS_DROPDOWN |
              WS_VSCROLL |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 95,           /* Posicin */
              120, 85,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_COMBO2,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SendMessage(hctrl, CB_SETEXTENDEDUI, (WPARAM)TRUE, 0);
           for(i = 0; i < 12; i++)
              SendMessage(hctrl, CB_ADDSTRING, 0, (LPARAM)mes[i]);
           hctrl = CreateWindowEx(
              0,
              "COMBOBOX",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              CBS_DROPDOWNLIST |
              WS_VSCROLL |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 185,          /* Posicin */
              120, 85,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_COMBO3,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           for(i = 0; i < 12; i++)
              SendMessage(hctrl, CB_ADDSTRING, 0, (LPARAM)mes[i]);
           pincel = CreateSolidBrush(RGB(0,255,0));
           pincel2 = CreateSolidBrush(RGB(0,255,255));
           return 0;
        case WM_CTLCOLOREDIT:
           SetTextColor((HDC)wParam, RGB(255,255,0));
           SetBkColor((HDC)wParam, RGB(0,255,255));
           return (LRESULT)pincel2;
        case WM_CTLCOLORLISTBOX:
           SetTextColor((HDC)wParam, RGB(255,0,0));
           SetBkColor((HDC)wParam, RGB(0,255,0));
           return (LRESULT)pincel;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case ID_COMBO3:
                hdc = GetWindowDC(hwnd);
                switch((int)HIWORD(wParam)) {
                  case CBN_SELENDCANCEL:
                     y=1;
                     strcpy(cad, "SELENDCANCEL");
                     break;
                  case CBN_SELENDOK:
                     y=2;
                     strcpy(cad, "SELENDOK");
                     break;
                  case CBN_DROPDOWN:
                     y=3;
                     strcpy(cad, "DROPDOWN");
                     break;
                  case CBN_CLOSEUP:
                     y=4;
                     strcpy(cad, "CLOSEUP");
                     break;
                  case CBN_DBLCLK:
                     y=5;
                     strcpy(cad, "Doble clic");
                     break;
                  case CBN_SELCHANGE:
                     y=6;
                     strcpy(cad, "CBN_SELCHANGE");
                     break;
                  case CBN_ERRSPACE:
                     y=7;
                     strcpy(cad, "CBN_ERRSPACE");
                     break;
                  case CBN_EDITCHANGE:
                     y=8;
                     strcpy(cad, "CBN_EDITCHANGE");
                     break;
                  case CBN_EDITUPDATE:
                     y=9;
                     strcpy(cad, "CBN_EDITUPDATE");
                     break;
                  case CBN_SETFOCUS:
                     Rectangle(hdc, 190, 150, 500, 370);
                     y=10;
                     strcpy(cad, "CBN_SETFOCUS");
                     break;
                  case CBN_KILLFOCUS:
                     y=11;
                     strcpy(cad, "CBN_KILLFOCUS");
                     break;
                  default:
                     y=12;
                     sprintf(cad, "%d", HIWORD(wParam));
                     break;
                }
                TextOut(hdc, 200, 150+y*18, cad, strlen(cad));
                i = SendDlgItemMessage(hwnd, ID_COMBO3, CB_GETCURSEL, 0, 0);
                if(i >= 0) {
                   SendDlgItemMessage(hwnd, ID_COMBO3, CB_GETLBTEXT, (WPARAM)i, (LPARAM)cad);
                   TextOut(hdc, 400, 150+y*18, cad, strlen(cad));
                }
                ReleaseDC(hwnd, hdc);
                break;
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           DeleteObject(pincel);
           DeleteObject(pincel2);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
