#include <windows.h>

#include "win072.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 072",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           300,                 /* Ancho */
           200,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    char* mes[] = {"Antonio", "Fernando", "Carlos", "Santiago",
      "Pilar", "Mara", "Julio", "Federico", "Flix"};
    int i, l;

    static HINSTANCE hInstance;
    static HFONT hfont;
    HWND hctrl;
    char cad[128];
    RECT re;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           hctrl = CreateWindowEx(
              0, "STATIC", "texto",
              SS_SIMPLE | SS_SUNKEN | WS_CHILD | WS_VISIBLE,
              5, 100, 150, 18,
              hwnd, (HMENU)ID_ESTAT, hInstance, NULL);
           /* Insertar control */
           hctrl = CreateWindowEx(
              0, "COMBOBOX",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              CBS_DROPDOWN | CBS_SORT |
              WS_VSCROLL |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 5,            /* Posicin */
              120, 85,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_COMBO,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           for(i = 0; i < 8; i++)
              SendMessage(hctrl, CB_ADDSTRING, 0, (LPARAM)mes[i]);
           SetFocus(hctrl);
           hctrl = CreateWindowEx(
              0, "BUTTON", "Aadir",
              BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              180, 5, 95, 24,
              hwnd, (HMENU)ID_INSERTAR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0, "BUTTON", "Siguiente",
              BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              180, 40, 95, 24,
              hwnd, (HMENU)ID_SIGUIENTE, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0, "BUTTON", "Anterior",
              BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              180, 75, 95, 24,
              hwnd, (HMENU)ID_ANTERIOR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0, "BUTTON", "Borrar",
              BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              180, 110, 95, 24,
              hwnd, (HMENU)ID_BORRAR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case ID_COMBO:
                switch(HIWORD(wParam)) {
                  case CBN_SELCHANGE:
                     i = SendDlgItemMessage(hwnd, ID_COMBO, CB_GETCURSEL, 0, 0);
                     if(i >= 0) {
                       SendDlgItemMessage(hwnd, ID_COMBO, CB_GETLBTEXT, (WPARAM)i, (LPARAM)cad);
                       SetWindowText(GetDlgItem(hwnd, ID_ESTAT), cad);
                       SetRect(&re, 5, 100, 155, 118);
                       InvalidateRect(hwnd, &re, TRUE);
                     }
                     break;
                  case CBN_KILLFOCUS:
                     SendDlgItemMessage(hwnd, ID_COMBO, WM_GETTEXT, 128, (LPARAM)cad);
                     SetWindowText(GetDlgItem(hwnd, ID_ESTAT), cad);
                     SetRect(&re, 5, 100, 155, 118);
                     InvalidateRect(hwnd, &re, TRUE);
                     break;
                }
                break;
              case ID_INSERTAR:
                l = SendDlgItemMessage(hwnd, ID_COMBO, WM_GETTEXT, 128, (LPARAM)cad);
                i = SendDlgItemMessage(hwnd, ID_COMBO, CB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)cad);
                if(l > 0 && i == CB_ERR)
                   SendDlgItemMessage(hwnd, ID_COMBO, CB_ADDSTRING, 0, (LPARAM)cad);
                break;
              case ID_SIGUIENTE:
                i = SendDlgItemMessage(hwnd, ID_COMBO, CB_GETCURSEL, 0, 0);
                SendDlgItemMessage(hwnd, ID_COMBO, CB_SETCURSEL, (WPARAM)i+1, 0);
                break;
              case ID_ANTERIOR:
                i = SendDlgItemMessage(hwnd, ID_COMBO, CB_GETCURSEL, 0, 0);
                SendDlgItemMessage(hwnd, ID_COMBO, CB_SETCURSEL, (WPARAM)i-1, 0);
                break;
              case ID_BORRAR:
                i = SendDlgItemMessage(hwnd, ID_COMBO, CB_GETCURSEL, 0, 0);
                SendDlgItemMessage(hwnd, ID_COMBO, CB_DELETESTRING, (WPARAM)i, 0);
                break;
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
