#include <windows.h>
#include <stdio.h>

#include "win073.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void MostrarAtributos(HWND);
void IniciarCombo(HWND, char*);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 073",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           450,                 /* Ancho */
           300,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    /* Variables para dilogo */
    static HFONT hfont;
    HWND hctrl;
    HWND hestatico;
    char cad[128];

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           hestatico = CreateWindowEx(
              0,
              "STATIC",        /* Nombre de la clase */
              "",              /* Texto del ttulo, no tiene */
              WS_CHILD | WS_VISIBLE | WS_BORDER, /* Estilo */
              9, 4,            /* Posicin */
              344, 18,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_TITULO,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hestatico, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "COMBOBOX",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              CBS_DROPDOWNLIST | CBS_SORT |
              WS_VSCROLL |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              9, 25,            /* Posicin */
              344, 85,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_COMBO,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SetFocus(hctrl);
           hctrl = CreateWindowEx(
              0,"STATIC", "", WS_CHILD | WS_VISIBLE,
              10, 60, 344, 18, hwnd, (HMENU)ID_ATRIBUTOS,
              hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,"STATIC", "", WS_CHILD | WS_VISIBLE,
              10, 85, 344, 18, hwnd, (HMENU)ID_CREACION,
              hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,"STATIC", "", WS_CHILD | WS_VISIBLE,
              10, 110, 344, 18, hwnd, (HMENU)ID_ACCESO,
              hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,"STATIC", "", WS_CHILD | WS_VISIBLE,
              10, 135, 344, 18, hwnd, (HMENU)ID_MODIFICA,
              hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,"STATIC", "", WS_CHILD | WS_VISIBLE,
              10, 160, 344, 18, hwnd, (HMENU)ID_TAMANO,
              hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           IniciarCombo(hwnd, "*.*");
           return 0;
        case WM_SETFOCUS:
           MostrarAtributos(hwnd);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case ID_COMBO:
                 switch(HIWORD(wParam)) {
                   case CBN_CLOSEUP:
                   case CBN_KILLFOCUS:
                      if(DlgDirSelectComboBoxEx(hwnd, cad, 512, ID_COMBO)) {
                         strcat(cad, "*.*");
                         IniciarCombo(hwnd, cad);
                      }
                      break;
                   case CBN_SELCHANGE:
                      MostrarAtributos(hwnd);
                      break;
                }
                break;
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

void MostrarAtributos(HWND hwnd) {
   char cad[256];
   WIN32_FILE_ATTRIBUTE_DATA wfat;
   SYSTEMTIME st;

   SendDlgItemMessage(hwnd, ID_COMBO, WM_GETTEXT, 128, (LPARAM)cad);

   GetFileAttributesEx(cad, GetFileExInfoStandard	, &wfat);
   strcpy(cad, "");
   //sprintf(cad, "%04x ",wfat.dwFileAttributes);
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE) strcat(cad, "Archivo");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_COMPRESSED) strcat(cad, " Comprimido");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) strcat(cad, " Directorio");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) strcat(cad, " Oculto");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_NORMAL) strcat(cad, " Normal");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_OFFLINE) strcat(cad, " Offline");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_READONLY) strcat(cad, " Slo lectura");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM) strcat(cad, " Sistema");
   if(wfat.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY) strcat(cad, " Temporal");
   SetWindowText(GetDlgItem(hwnd, ID_ATRIBUTOS), cad);
   SetWindowText(GetDlgItem(hwnd, ID_CREACION), "");
   SetWindowText(GetDlgItem(hwnd, ID_ACCESO), "");
   SetWindowText(GetDlgItem(hwnd, ID_MODIFICA), "");
   SetWindowText(GetDlgItem(hwnd, ID_TAMANO), "");

   if(!(wfat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
      FileTimeToSystemTime(&wfat.ftCreationTime, &st);
      sprintf(cad, "Fecha de creacin: %02d/%02d/%04d %02d:%02d:%02d",
        st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond);
      SetWindowText(GetDlgItem(hwnd, ID_CREACION), cad);
      FileTimeToSystemTime(&wfat.ftLastAccessTime, &st);
      sprintf(cad, "ltimo acceso: %02d/%02d/%04d %02d:%02d:%02d",
        st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond);
      SetWindowText(GetDlgItem(hwnd, ID_ACCESO), cad);
      FileTimeToSystemTime(&wfat.ftLastWriteTime, &st);
      sprintf(cad, "ltima modificacin: %02d/%02d/%04d %02d:%02d:%02d",
        st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond);
      SetWindowText(GetDlgItem(hwnd, ID_MODIFICA), cad);
      if(wfat.nFileSizeHigh > 0)
         sprintf(cad, "Tamao: %ld GB", wfat.nFileSizeHigh*4);
      else {
        if(wfat.nFileSizeLow > 1073741824L)
           sprintf(cad, "Tamao: %.3f GB", (float)wfat.nFileSizeLow/1073741824L);
        else
        if(wfat.nFileSizeLow > 1048576)
           sprintf(cad, "Tamao: %.3f MB", (float)wfat.nFileSizeLow/1048576);
        else
        if(wfat.nFileSizeLow > 1024)
           sprintf(cad, "Tamao: %.3f KB", (float)wfat.nFileSizeLow/1024);
        else
           sprintf(cad, "Tamao: %ld B", wfat.nFileSizeLow);
      }
      SetWindowText(GetDlgItem(hwnd, ID_TAMANO), cad);
   }
}

void IniciarCombo(HWND hwnd, char* p)
{
   char path[512];

   strcpy(path, p);

   DlgDirListComboBox(
    hwnd,           /* manipulador de cuadro de dilogo con list box  */
    path,           /* puntero a cadena de camino o nombre de fichero */
    ID_COMBO,       /* identificador de list box                      */
    ID_TITULO,      /* identificador de control esttico              */
    DDL_DIRECTORY | DDL_DRIVES /* atributos de ficheros a mostrar     */
   );
   SendDlgItemMessage(hwnd, ID_COMBO, CB_SETCURSEL, 0, 1);
   MostrarAtributos(hwnd);
}
