#include <windows.h>
#include "win074.h"

struct stComida {
   char nombre[64];
   char tipo;
};

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 074",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           450,                 /* Ancho */
           300,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    struct stComida comida[] = {
       {"Cerveza", 'b'},
       {"Hamburguesa", 'c'},
       {"Pastel", 'p'},
       {"Queso", 'c'},
       {"Huevo", 'c'},
       {"Naranja", 'p'},
       {"Perrito", 'c'},
       {"Helado", 'p'},
       {"Pizza", 'c'},
       {"Vino", 'b'}
    };
    static HINSTANCE hInstance;
    HICON icono;
    HWND hctrl;
    int i;
    int y;
    MEASUREITEMSTRUCT *lpmis;
    DRAWITEMSTRUCT *lpdis;
    TEXTMETRIC tm;
    COMPAREITEMSTRUCT *lpcis;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "COMBOBOX",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              //CBS_HASSTRINGS |
              CBS_OWNERDRAWFIXED |
              CBS_DROPDOWNLIST | CBS_SORT |
              WS_VSCROLL |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              9, 25,            /* Posicin */
              344, 250,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_COMBO,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SetFocus(hctrl);
           for(i = 0; i < 10; i++)
             SendDlgItemMessage(hwnd, ID_COMBO, CB_ADDSTRING, 0, i);

           SendDlgItemMessage(hwnd, ID_COMBO, CB_SETCURSEL, 0, 1);
           return 0;
        case WM_MEASUREITEM:
           lpmis = (LPMEASUREITEMSTRUCT) lParam;
           lpmis->itemHeight = 40;
           return TRUE;
        case WM_DRAWITEM:
           lpdis = (LPDRAWITEMSTRUCT) lParam;
           if(lpdis->itemID == -1) {  /* Se trata de un men, no hacer nada */
              break;
           }
           switch (lpdis->itemAction) {
             case ODA_SELECT:
             case ODA_DRAWENTIRE:
             case ODA_FOCUS:
               /* Borrar el contenido previo */
               FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH)(COLOR_WINDOW+1));
               /* Obtener datos de las medidas de la fuente */
               GetTextMetrics(lpdis->hDC, &tm);
               /* Calcular la coordenada y para escribir el texto de tem */
               y = (lpdis->rcItem.bottom + lpdis->rcItem.top - tm.tmHeight) / 2;
               /* Cada tipo de comida se muestra en un color diferente */
               if(comida[lpdis->itemData].tipo == 'p')
                  SetTextColor(lpdis->hDC, RGB(0,128,0));
               else
               if(comida[lpdis->itemData].tipo == 'c')
                  SetTextColor(lpdis->hDC, RGB(0,0,255));
               else
               if(comida[lpdis->itemData].tipo == 'b')
                  SetTextColor(lpdis->hDC, RGB(255,0,0));
               /* Mostrar el icono */
               icono = LoadIcon(hInstance, MAKEINTRESOURCE(Icono+lpdis->itemData));
               DrawIcon(lpdis->hDC, 4, lpdis->rcItem.top+2, icono);
               DeleteObject(icono);
               /* Mostrar el texto */
               SelectObject(lpdis->hDC, (HFONT)GetStockObject(DEFAULT_GUI_FONT));
               TextOut(lpdis->hDC, 42, y,
                  comida[lpdis->itemData].nombre,
                  strlen(comida[lpdis->itemData].nombre));
               /* Si el tem est seleccionado, trazar un rectngulo negro alrededor */
               if (lpdis->itemState & ODS_SELECTED) {
                 SetTextColor(lpdis->hDC, RGB(0,0,0));
                 DrawFocusRect(lpdis->hDC, &lpdis->rcItem);
               }
           }
           break;
        case WM_COMPAREITEM:
           lpcis = (LPCOMPAREITEMSTRUCT) lParam;
           /* Establecer un orden:
              1) Por tipos, primero comidas, despus postres y ltimo bebidas
              2) Dentro de cada tipo, usar el orden alfabtico */
           if(comida[lpcis->itemData1].tipo == comida[lpcis->itemData2].tipo)
              return strcmp(comida[lpcis->itemData1].nombre, comida[lpcis->itemData2].nombre);
           else if(comida[lpcis->itemData1].tipo == 'c') return -1;
           else if(comida[lpcis->itemData1].tipo == 'b') return 1;
           else if(comida[lpcis->itemData2].tipo == 'c') return 1;
           else return -1;
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
