#include <windows.h>
#include <winspool.h>

#define ID_LISTA 101
#define CM_IMPRIMIR 102

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 078",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           455,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HDC hPrinterDC;
    HWND hctrl;
    DWORD tamano, numero;
    PRINTER_INFO_4 *info;
    char impresora[256];
    int i;
    DOCINFO di;
    HBITMAP hBitmap;
    HDC memDC;
    BITMAP bm;
    int ancho, alto;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "LISTBOX",      /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              LBS_STANDARD | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              9, 19,           /* Posicin */
              500, 350,         /* Tamao */
              hwnd,           /* Ventana padre */
              (HMENU)ID_LISTA, /* Identificador del control */
              hInstance,      /* Instancia */
              NULL);          /* Sin datos de creacin de ventana */
           CreateWindowEx(
              0,
              "BUTTON",      /* Nombre de la clase */
              "Imprimir",           /* Texto del ttulo */
              BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              9, 370,           /* Posicin */
              95, 24,         /* Tamao */
              hwnd,           /* Ventana padre */
              (HMENU)CM_IMPRIMIR, /* Identificador del control */
              hInstance,      /* Instancia */
              NULL);          /* Sin datos de creacin de ventana */
           EnumPrinters(PRINTER_ENUM_LOCAL | PRINTER_ENUM_CONNECTIONS,
               NULL,
               4,
               NULL,
               0,
               &tamano,
               &numero);
           info = (PRINTER_INFO_4*)malloc(tamano);
           EnumPrinters(PRINTER_ENUM_LOCAL|PRINTER_ENUM_CONNECTIONS,
               NULL,
               4,
               (BYTE*)info,
               tamano,
               &tamano,
               &numero);
           for(i = 0; i < numero; i++) {
               SendMessage(hctrl, LB_ADDSTRING, 0, (LPARAM)info[i].pPrinterName);
           }
           SendMessage(hctrl, LB_SETCURSEL, 0, 0);
           free(info);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_IMPRIMIR:
                hBitmap = (HBITMAP)LoadImage(NULL, "meninas24.bmp", IMAGE_BITMAP,
                    0, 0, LR_LOADFROMFILE);
                GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
                i = SendDlgItemMessage(hwnd, ID_LISTA, LB_GETCURSEL, 0, 0);
                SendDlgItemMessage(hwnd, ID_LISTA, LB_GETTEXT, (WPARAM)i, (LPARAM)impresora);
                hPrinterDC = CreateDC("WINSPOOL", impresora, NULL, NULL);
                ancho = GetDeviceCaps(hPrinterDC, HORZRES);
                alto = GetDeviceCaps(hPrinterDC, VERTRES);
                di.cbSize = sizeof(DOCINFO);
                di.lpszDocName = "Prueba";
                di.lpszOutput = NULL;
                di.lpszDatatype = NULL;
                di.fwType = 0;
                StartDoc(hPrinterDC, &di);
                StartPage(hPrinterDC);
                TextOut(hPrinterDC, 10, 10, "Hola, mundo!", 12);
                Ellipse(hPrinterDC, 150, 180, ancho-150, alto-180);
                EndPage(hPrinterDC);
                StartPage(hPrinterDC);
                memDC = CreateCompatibleDC(hPrinterDC);
                SelectObject(memDC, hBitmap);
                StretchBlt(hPrinterDC, 300, 300, ancho-600, alto-600, memDC, 0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
                DeleteDC(memDC);
                EndPage(hPrinterDC);
                EndDoc(hPrinterDC);
                DeleteDC(hPrinterDC);
                DeleteObject(hBitmap);
                break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

