#include <windows.h>
#include <commctrl.h>

#define CM_FOCUS        101
#define CM_SELECTED     102
#define CM_NORMAL       103
#define CM_TRANSPARENTE 104

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 081",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           480,                 /* Ancho */
           215,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HIMAGELIST hIml;
    static HIMAGELIST hIml2;
    static HIMAGELIST hIml3;
    HBITMAP hbmp;
    HBITMAP hbmp2;
    HICON hicon;
    HDC hDC;
    PAINTSTRUCT ps;
    int i;
    static int tipo=1;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
//           hIml = ImageList_LoadBitmap(hInstance, "mapabits", 32, 4, CLR_NONE);
//           hIml = ImageList_LoadImage(hInstance, "mapabits", 32, 4, CLR_NONE, IMAGE_BITMAP, LR_CREATEDIBSECTION);

           hIml = ImageList_Create(32, 32, ILC_COLOR16, 10, 4);
           hIml2 = ImageList_Create(32, 32, ILC_COLOR16 | ILC_MASK, 5, 2);
           hbmp = LoadBitmap(hInstance, "mapabits");
           ImageList_Add(hIml, hbmp, 0);
           DeleteObject(hbmp);
           hicon = LoadIcon(hInstance, "tierra");
           ImageList_AddIcon(hIml, hicon);

           hbmp = LoadBitmap(hInstance, "carpeta1");
           ImageList_AddMasked(hIml2, hbmp, RGB(255,255,255));

           DeleteObject(hbmp);
           hbmp = LoadBitmap(hInstance, "carpeta2");
           ImageList_AddMasked(hIml2, hbmp, RGB(255,255,255));
           DeleteObject(hbmp);
           hbmp2 = LoadBitmap(hInstance, "docmask");
           hbmp = LoadBitmap(hInstance, "doc1");
           ImageList_AddMasked(hIml2, hbmp, RGB(255,0,128));
           ImageList_Add(hIml2, hbmp, hbmp2);
           DeleteObject(hbmp);
           hbmp = LoadBitmap(hInstance, "doc2");
           ImageList_Add(hIml2, hbmp, hbmp2);
           DeleteObject(hbmp);
           hbmp = LoadBitmap(hInstance, "doc3");
           ImageList_Add(hIml2, hbmp, hbmp2);
           DeleteObject(hbmp2);
           DeleteObject(hbmp);

           hicon = LoadIcon(hInstance, "tierra");
           ImageList_AddIcon(hIml2, hicon);
           hicon = LoadIcon(hInstance, "fax");
           ImageList_AddIcon(hIml2, hicon);
           hicon = LoadIcon(hInstance, "casa");
           ImageList_AddIcon(hIml2, hicon);
           i=ImageList_AddIcon(hIml2, hicon);
           hbmp2 = LoadBitmap(hInstance, "docmask");
           hbmp = LoadBitmap(hInstance, "doc1");
           ImageList_Replace(hIml2, i, hbmp, hbmp2);
           DeleteObject(hbmp2);
           DeleteObject(hbmp);
           ImageList_ReplaceIcon(hIml, 9, hicon);

           hbmp = LoadBitmap(hInstance, "mundito");
           i = ImageList_AddMasked(hIml2, hbmp, RGB(255,255,255));
           DeleteObject(hbmp);
           ImageList_SetOverlayImage(hIml2, i, 1);

           hIml3 = ImageList_Merge(hIml2, 2, hIml2, 10, 0, 0);

           ImageList_SetBkColor(hIml, GetSysColor(COLOR_MENU)); //RGB(255,0,0)); //GetSysColorBrush(COLOR_MENU));
           ImageList_SetBkColor(hIml2, GetSysColor(COLOR_MENU));//RGB(255,0,0)); //GetSysColorBrush(COLOR_MENU));

           CreateWindowEx(0, "BUTTON", "25%", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              10, 10, 95, 20, hwnd, (HMENU)CM_FOCUS, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "50%", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              110, 10, 95, 20, hwnd, (HMENU)CM_SELECTED, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "Normal", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              210, 10, 95, 20, hwnd, (HMENU)CM_NORMAL, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "Transparente", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              310, 10, 95, 20, hwnd, (HMENU)CM_TRANSPARENTE, hInstance, NULL);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case CM_FOCUS:
                    tipo=1;
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
                case CM_SELECTED:
                    tipo=2;
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
                case CM_NORMAL:
                    tipo=3;
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
                case CM_TRANSPARENTE:
                    tipo=4;
                    InvalidateRect(hwnd, NULL, TRUE);
                    break;
           }
           break;
        case WM_PAINT:
           hDC = BeginPaint(hwnd, &ps);
           for(i = 0; i < 480; i+=10) {
                MoveToEx(hDC, i, 0, NULL);
                LineTo(hDC, i, 215);
           }
           switch(tipo) {
            case 1:
                for(i = 0; i < 11; i++)
                    if(i % 2) ImageList_Draw(hIml, i, hDC, 10+40*i, 40, ILD_BLEND25 | ILD_NORMAL);
                    else ImageList_DrawEx(hIml, i, hDC, 10+40*i, 40, 0, 0, GetSysColor(COLOR_MENU), RGB(255,0,0) , ILD_BLEND25 | ILD_NORMAL);
                for(i = 0; i < 11; i++) {
                    if(i % 2) ImageList_Draw(hIml2, i, hDC, 10+40*i, 90, ILD_BLEND25 | ILD_TRANSPARENT);
                    else ImageList_DrawEx(hIml2, i, hDC, 10+40*i, 90, 32, 32, GetSysColor(COLOR_MENU), RGB(255,0,0), ILD_BLEND25 | ILD_TRANSPARENT);
                }
                ImageList_Draw(hIml3, 0, hDC, 10, 130, ILD_BLEND25 | ILD_TRANSPARENT);
                break;
            case 2:
                for(i = 0; i < 11; i++)
                    if(i % 2) ImageList_Draw(hIml, i, hDC, 10+40*i, 40, ILD_BLEND50 | ILD_NORMAL);
                    else ImageList_DrawEx(hIml, i, hDC, 10+40*i, 40, 32, 32, GetSysColor(COLOR_MENU), RGB(255,0,0), ILD_BLEND50 | ILD_NORMAL);
                for(i = 0; i < 11; i++) {
                    if(i % 2) ImageList_Draw(hIml2, i, hDC, 10+40*i, 90, ILD_BLEND50 | ILD_TRANSPARENT);
                    else ImageList_DrawEx(hIml2, i, hDC, 10+40*i, 90, 32, 32, GetSysColor(COLOR_MENU), RGB(255,0,0), ILD_BLEND50 | ILD_TRANSPARENT);
                }
                ImageList_Draw(hIml3, 0, hDC, 10, 130, ILD_BLEND50 | ILD_TRANSPARENT);
                break;
            case 3:
                for(i = 0; i < 11; i++)
                    if(i % 2) ImageList_Draw(hIml, i, hDC, 10+40*i, 40, ILD_NORMAL);
                    else ImageList_DrawEx(hIml, i, hDC, 10+40*i, 40, 32, 32, GetSysColor(COLOR_MENU), RGB(255,255,255), ILD_NORMAL);
                for(i = 0; i < 11; i++) {
                    if(i % 2) ImageList_Draw(hIml2, i, hDC, 10+40*i, 90, ILD_NORMAL);
                    else ImageList_DrawEx(hIml2, i, hDC, 10+40*i, 90, 32, 32, GetSysColor(COLOR_MENU), RGB(255,255,255), ILD_NORMAL);
                }
                ImageList_Draw(hIml3, 0, hDC, 10, 130, ILD_NORMAL);
                break;
            case 4:
                for(i = 0; i < 11; i++)
                    if(i % 2) ImageList_Draw(hIml, i, hDC, 10+40*i, 40, ILD_TRANSPARENT);
                    else ImageList_DrawEx(hIml, i, hDC, 10+40*i, 40, 32, 32, GetSysColor(COLOR_MENU), RGB(255,255,255), ILD_TRANSPARENT);
                for(i = 0; i < 11; i++) {
                    if(i % 2) ImageList_Draw(hIml2, i, hDC, 10+40*i, 90, ILD_TRANSPARENT | INDEXTOOVERLAYMASK(1));
                    else ImageList_DrawEx(hIml2, i, hDC, 10+40*i, 90, 32, 32, GetSysColor(COLOR_MENU), RGB(255,255,255), ILD_TRANSPARENT);
                }
                ImageList_Draw(hIml3, 0, hDC, 10, 130, ILD_TRANSPARENT);
                break;
           }
           EndPaint(hwnd, &ps);
           break;
        case WM_DESTROY:
           ImageList_Destroy(hIml);
           ImageList_Destroy(hIml2);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
