#include <windows.h>
#include <commctrl.h>

#define ID_STATUS 100

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 084",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           480,                 /* Ancho */
           215,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static BOOL numlock;
    static BOOL caplock;
    static BOOL blqlock;
    RECT re;
    int anchura[] = {54, 74, 94, -1};

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           CreateStatusWindow(WS_CHILD|WS_VISIBLE, "Texto de prueba", hwnd, ID_STATUS);
           numlock = (GetKeyState(VK_NUMLOCK) & 1) == 1;
           caplock = (GetKeyState(VK_CAPITAL) & 1) == 1;
           blqlock = (GetKeyState(VK_SCROLL) & 1) == 1;
           return 0;
        case WM_SIZE:
           GetClientRect(hwnd, &re);
           anchura[3] = re.right-20;
           anchura[2] = anchura[3]-60;
           anchura[1] = anchura[2]-60;
           anchura[0] = anchura[1]-60;
           SendDlgItemMessage(hwnd, ID_STATUS, SB_SETPARTS, 4, (LPARAM)anchura);
           SendDlgItemMessage(hwnd, ID_STATUS, msg, wParam, lParam);
           if(numlock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3, (LPARAM)"\tbloq num");
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3, (LPARAM)"");
           if(caplock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 2, (LPARAM)"\tbloq may");
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 2, (LPARAM)"");
           if(blqlock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 1, (LPARAM)"\tbloq scr");
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 1, (LPARAM)"");
           break;
        case WM_KEYDOWN:
           numlock = (GetKeyState(VK_NUMLOCK) & 1) == 1;
           caplock = (GetKeyState(VK_CAPITAL) & 1) == 1;
           blqlock = (GetKeyState(VK_SCROLL) & 1) == 1;
           if(numlock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3|SBT_POPOUT, (LPARAM)"\tbloq num");
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3, (LPARAM)"");
           if(caplock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 2, (LPARAM)"\tbloq may");
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 2, (LPARAM)"");
           if(blqlock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 1, (LPARAM)"\tbloq scr");
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 1, (LPARAM)"");
          break;
        case WM_COMMAND:
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
