//#define _WIN32_WINNT  0x0501
//#define  WINVER       0x0501
//#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include "win086.h"

#define ID_PROGRESSBAR1 100
#define ID_PROGRESSBAR2 101
#define CM_DIALOG       102

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 086",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           300,                 /* Ancho */
           150,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static int val;
    RECT re;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           GetClientRect(hwnd, &re);
           CreateWindowEx(0, PROGRESS_CLASS, (LPSTR)NULL, WS_CHILD | WS_VISIBLE, 10, 30, re.right-20, 20, hwnd,
                          (HMENU)ID_PROGRESSBAR1, hInstance, NULL);
           CreateWindowEx(0, PROGRESS_CLASS, (LPSTR)NULL, WS_CHILD | WS_VISIBLE | PBS_SMOOTH, 10, 60, re.right-20, 20, hwnd,
                          (HMENU)(ID_PROGRESSBAR2), hInstance, NULL);
           CreateWindowEx(0, "BUTTON", (LPSTR)"Dilogo", WS_CHILD | WS_VISIBLE, 40, 2, 80, 24, hwnd,
                          (HMENU)(CM_DIALOG), hInstance, NULL);
           SendDlgItemMessage(hwnd, ID_PROGRESSBAR1, PBM_SETRANGE32, 0, 200);
           SendDlgItemMessage(hwnd, ID_PROGRESSBAR2, PBM_SETRANGE32, 0, 200);
           SendDlgItemMessage(hwnd, ID_PROGRESSBAR2, PBM_SETPOS, 200, 0);
           SendDlgItemMessage(hwnd, ID_PROGRESSBAR1, PBM_SETSTEP, (WPARAM) 5, 0);
//           SendDlgItemMessage(hwnd, ID_PROGRESSBAR1, PBM_SETBARCOLOR, 0, (LPARAM)RGB(255,120,90));
//           SendDlgItemMessage(hwnd, ID_PROGRESSBAR1, PBM_SETBKCOLOR, 0, (LPARAM)RGB(0,0,0));
           val = 0;
           SetTimer(hwnd, 1, 15, NULL);
           return 0;
        case WM_SIZE:
           GetClientRect(hwnd, &re);
           MoveWindow(GetDlgItem(hwnd, ID_PROGRESSBAR1), 10, 30, re.right-20, 20, TRUE);
           MoveWindow(GetDlgItem(hwnd, ID_PROGRESSBAR2), 10, 60, re.right-20, 20, TRUE);
           break;
        case WM_TIMER:
           switch(wParam) {
              case 1:
                 val+=1;
                 SendDlgItemMessage(hwnd, ID_PROGRESSBAR1, PBM_SETPOS, (WPARAM)val, 0);
                 SendDlgItemMessage(hwnd, ID_PROGRESSBAR2, PBM_DELTAPOS, (WPARAM)-1, 0);
                 if(val >= 200) {
                     KillTimer(hwnd, 1);
                     SetTimer(hwnd, 2, 3000, NULL);
                 }
                 break;
              case 2:
                 KillTimer(hwnd, 2);
                 val = 0;
                 SendDlgItemMessage(hwnd, ID_PROGRESSBAR1, PBM_SETPOS, (WPARAM)0, 0);
                 SendDlgItemMessage(hwnd, ID_PROGRESSBAR2, PBM_SETPOS, (WPARAM)200, 0);
                 SetTimer(hwnd, 1, 15, NULL);
                 break;
           }
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case CM_DIALOG:
                    DialogBoxParam(hInstance, "Dialogo", hwnd, DlgProc, 0);
                    break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_INITDIALOG:
           SendDlgItemMessage(hDlg, IDC_PROGRESO, PBM_SETRANGE, 0, MAKELPARAM(0, 20));
           SendDlgItemMessage(hDlg, IDC_PROGRESO, PBM_SETPOS, (WPARAM)10, 0);
           return TRUE;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case IDC_BOTONMAS:
                    SendDlgItemMessage(hDlg, IDC_PROGRESO, PBM_DELTAPOS, (WPARAM)1, 0);
                    break;
                case IDC_BOTONMENOS:
                    SendDlgItemMessage(hDlg, IDC_PROGRESO, PBM_DELTAPOS, (WPARAM)-1, 0);
                    break;
                case IDOK:
                    EndDialog(hDlg, FALSE);
                    break;
           }
           return TRUE;
    }
    return FALSE;
}
