#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#ifndef TTM_SETTILE
#ifdef UNICODE
#define TTM_SETTITLE TTM_SETTITLEW
#else
#define TTM_SETTITLE TTM_SETTITLEA
#endif
#endif

#ifndef TTI_NONE
// ToolTip Icons (Set with TTM_SETTITLE)
#define TTI_NONE                0
#define TTI_INFO                1
#define TTI_WARNING             2
#define TTI_ERROR               3
#if (_WIN32_WINNT >= 0x0600)
#define TTI_INFO_LARGE          4
#define TTI_WARNING_LARGE       5
#define TTI_ERROR_LARGE         6
#endif  // (_WIN32_WINNT >= 0x0600)
#endif

#include "win087.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 087",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           300,                 /* Ancho */
           150,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HWND hwndTip;
    TOOLINFO toolInfo = { 0 };
    HICON hIcon;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           CreateWindowEx(0, "BUTTON", (LPSTR)"Deshabilitar", WS_CHILD | WS_VISIBLE, 40, 2, 90, 24, hwnd,
                          (HMENU)(CM_DESHABILITAR), hInstance, NULL);
           CreateWindowEx(0, "BUTTON", (LPSTR)"Habilitar", WS_CHILD | WS_VISIBLE, 140, 2, 90, 24, hwnd,
                          (HMENU)(CM_HABILITAR), hInstance, NULL);
           hwndTip = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLTIPS_CLASS, NULL,
                              WS_POPUP | TTS_BALLOON,
                              CW_USEDEFAULT, CW_USEDEFAULT,
                              CW_USEDEFAULT, CW_USEDEFAULT,
                              hwnd, (HMENU)0,
                              hInstance, NULL);
           if(hwndTip) {
                SetWindowPos(hwndTip, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
                // Eliminar manifiesto del fichero RC para que los cambios de color funcionen:
                SendMessage(hwndTip, TTM_SETTIPTEXTCOLOR, (WPARAM)RGB(255,0,0), 0);
                SendMessage(hwndTip, TTM_SETTIPBKCOLOR, (WPARAM)RGB(240,255,255), 0);
                hIcon = LoadIcon(hInstance, "Icono");
                SendMessage(hwndTip, TTM_SETTITLE, (WPARAM)hIcon, (LPARAM)"Ejemplo 087");
                DestroyIcon(hIcon);

                SendMessage(hwndTip, TTM_SETMAXTIPWIDTH, 0, 150);

                toolInfo.cbSize = sizeof(toolInfo);
                toolInfo.hwnd = hwnd;
                toolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
                toolInfo.uId = (UINT_PTR)GetDlgItem(hwnd, CM_DESHABILITAR);
                toolInfo.lpszText = "Este botn deshabilita los tooltips.";
                SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
                toolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
                toolInfo.uId = (UINT_PTR)GetDlgItem(hwnd, CM_HABILITAR);
                toolInfo.hinst = hInstance;
                toolInfo.lpszText = (LPTSTR)STR_HABILITAR;
                SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
                toolInfo.uFlags = TTF_SUBCLASS;
                toolInfo.uId = 0;
                GetClientRect(hwnd, &toolInfo.rect);
                toolInfo.hinst = 0;
                toolInfo.lpszText = "Esta es la ventana del ejemplo 87";
                SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
           }
           return 0;
        case WM_SIZE:
           toolInfo.cbSize = sizeof(toolInfo);
           toolInfo.uFlags = TTF_SUBCLASS;
           toolInfo.hwnd = hwnd;
           GetClientRect(hwnd, &toolInfo.rect);
           SendMessage(hwndTip, TTM_DELTOOL, 0, (LPARAM)&toolInfo);
           toolInfo.rect.right = toolInfo.rect.left + LOWORD(lParam);
           toolInfo.rect.bottom = toolInfo.rect.top + HIWORD(lParam);
           toolInfo.lpszText = "Esta es la ventana del ejemplo 87";
           SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case CM_DESHABILITAR:
                    SendMessage(hwndTip, TTM_ACTIVATE, (WPARAM)FALSE, 0);
                    break;
                case CM_HABILITAR:
                    SendMessage(hwndTip, TTM_ACTIVATE, (WPARAM)TRUE, 0);
                    break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
