#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#ifndef TTM_SETTILE
#ifdef UNICODE
#define TTM_SETTITLE TTM_SETTITLEW
#else
#define TTM_SETTITLE TTM_SETTITLEA
#endif
#endif

typedef struct tagNMTTCUSTOMDRAW {
  NMCUSTOMDRAW nmcd;
  UINT         uDrawFlags;
} NMTTCUSTOMDRAW, *LPNMTTCUSTOMDRAW;

#ifndef TTI_NONE
// ToolTip Icons (Set with TTM_SETTITLE)
#define TTI_NONE                0
#define TTI_INFO                1
#define TTI_WARNING             2
#define TTI_ERROR               3
#if (_WIN32_WINNT >= 0x0600)
#define TTI_INFO_LARGE          4
#define TTI_WARNING_LARGE       5
#define TTI_ERROR_LARGE         6
#endif  // (_WIN32_WINNT >= 0x0600)
#endif

#include "win089.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 089",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           320,                 /* Ancho */
           110,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HWND hwndTip;
    static HFONT hFont;
    static HPEN hPen;
    static int mostrado=0;
    static int ocultado=0;
    TOOLINFO toolInfo = { 0 };
    LPNMHDR pnmhdr;
    LPNMTTCUSTOMDRAW pnmttcustomdraw;
    HDC hdc;
    PAINTSTRUCT ps;
    char cad[256];

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hFont = CreateFont(-30, 0, 0, 450, 300, FALSE, FALSE, FALSE,
                DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Times New Roman");
           hPen = CreatePen(PS_SOLID, 4, RGB(255,0,0));
           CreateWindowEx(0, "BUTTON", (LPSTR)"Botn 1", WS_CHILD | WS_VISIBLE, 10, 10, 90, 24, hwnd,
                          (HMENU)(CM_BOTON1), hInstance, NULL);
           CreateWindowEx(0, "BUTTON", (LPSTR)"Botn 2", WS_CHILD | WS_VISIBLE, 105, 10, 90, 24, hwnd,
                          (HMENU)(CM_BOTON2), hInstance, NULL);
           CreateWindowEx(0, "BUTTON", (LPSTR)"No pulsar!!", WS_CHILD | WS_VISIBLE, 200, 10, 90, 24, hwnd,
                          (HMENU)(CM_BOTON3), hInstance, NULL);
           hwndTip = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLTIPS_CLASS, NULL,
                              WS_POPUP,
                              CW_USEDEFAULT, CW_USEDEFAULT,
                              CW_USEDEFAULT, CW_USEDEFAULT,
                              hwnd, (HMENU)0,
                              hInstance, NULL);
           if(hwndTip) {
                SetWindowPos(hwndTip, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
                SendMessage(hwndTip, TTM_SETMAXTIPWIDTH, 0, 230);

                toolInfo.cbSize = sizeof(toolInfo);
                toolInfo.hwnd = hwnd;
                toolInfo.hinst = hInstance;
                toolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
                toolInfo.uId = (UINT_PTR)GetDlgItem(hwnd, CM_BOTON1);
                toolInfo.lpszText = (LPSTR)STR_BOTON1;
                SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
                toolInfo.uId = (UINT_PTR)GetDlgItem(hwnd, CM_BOTON2);
                toolInfo.lpszText = (LPSTR)STR_BOTON2;
                SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
                toolInfo.uId = (UINT_PTR)GetDlgItem(hwnd, CM_BOTON3);
                toolInfo.lpszText = (LPSTR)STR_BOTON3;
                SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
           }
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case CM_BOTON1:
                    break;
                case CM_BOTON2:
                    break;
                case CM_BOTON3:
                    MessageBox(hwnd, "Te dije que no pulsaras...", "Autodestruccin", MB_OK);
                    PostQuitMessage(0);
                    break;
           }
           break;
        case WM_NOTIFY:
           pnmhdr = (LPNMHDR)lParam;
           switch(pnmhdr->code) {
             case TTN_SHOW:
                mostrado++;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
             case TTN_POP:
                ocultado++;
                InvalidateRect(hwnd, NULL, TRUE);
                break;
             case NM_CUSTOMDRAW:
                pnmttcustomdraw = (LPNMTTCUSTOMDRAW)pnmhdr;
                if(pnmttcustomdraw->nmcd.hdr.hwndFrom == hwndTip &&
                   GetDlgCtrlID((HWND)pnmttcustomdraw->nmcd.hdr.idFrom) == CM_BOTON3 &&
                   pnmttcustomdraw->nmcd.dwDrawStage == CDDS_PREPAINT) {
                    SelectObject(pnmttcustomdraw->nmcd.hdc, hFont);
                    SetTextColor(pnmttcustomdraw->nmcd.hdc, RGB(255,0,0));
                    return CDRF_NEWFONT | CDRF_NOTIFYPOSTPAINT;
                } else
                if(pnmttcustomdraw->nmcd.hdr.hwndFrom == hwndTip &&
                   GetDlgCtrlID((HWND)pnmttcustomdraw->nmcd.hdr.idFrom) == CM_BOTON3 &&
                   pnmttcustomdraw->nmcd.dwDrawStage == CDDS_POSTPAINT) {
                    SelectObject(pnmttcustomdraw->nmcd.hdc, GetStockObject(HOLLOW_BRUSH));
                    SelectObject(pnmttcustomdraw->nmcd.hdc, hPen);
                    Rectangle(pnmttcustomdraw->nmcd.hdc,
                              pnmttcustomdraw->nmcd.rc.left,
                              pnmttcustomdraw->nmcd.rc.top,
                              pnmttcustomdraw->nmcd.rc.right,
                              pnmttcustomdraw->nmcd.rc.bottom);
                    return CDRF_SKIPDEFAULT;
                } else
                return CDRF_DODEFAULT;
                break;
           }
           break;
        case WM_PAINT:
           hdc = BeginPaint(hwnd, &ps);
           SetBkMode(hdc, TRANSPARENT);
           sprintf(cad, "Mostrado=%d  Ocultado=%d", mostrado, ocultado);
           TextOut(hdc, 10, 40, cad, strlen(cad));
           EndPaint(hwnd, &ps);
           break;
        case WM_DESTROY:
           DeleteObject(hFont);
           DeleteObject(hPen);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
