#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win092.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
int InsertarItem(HWND hwndHeader, HINSTANCE, int iDespuesDe, int nAncho, char* bm, char* texto);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 092",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           350,                 /* Ancho */
           120,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hFont;
    RECT rc;
    HDLAYOUT hdl;
    WINDOWPOS wp;
    LPNMHEADER pnmhdr;
    int iItem;
    char mensaje[128];

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(32, 0, 0, 0, 300, FALSE, FALSE, FALSE,
                DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Times New Roman");
            CreateWindowEx(0, WC_HEADER, NULL,
                WS_CHILD | HDS_HORZ | HDS_DRAGDROP | HDS_OVERFLOW | HDS_FULLDRAG,
                0, 0, 0, 0,
                hwnd, (HMENU)ID_HEADER1,
                hInstance, NULL);
            // Asignamos la fuente a nuestro gusto.
            SendDlgItemMessage(hwnd, ID_HEADER1, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE, 0));
            // Ajustar dimensiones y posicin en funcin de la ventana padre.
            GetClientRect(hwnd, &rc);
            hdl.prc = &rc;
            hdl.pwpos = &wp;
            SendDlgItemMessage(hwnd, ID_HEADER1, HDM_LAYOUT, 0, (LPARAM)&hdl);
            /* O bien la macro:
            Header_Layout(GetDlgItem(hwnd, ID_HEADER1), &hdl);
            */
            SetWindowPos(GetDlgItem(hwnd, ID_HEADER1), wp.hwndInsertAfter, wp.x, wp.y,
                wp.cx, wp.cy, wp.flags | SWP_SHOWWINDOW );
            // Insertar columnas.
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), hInstance, 0, 90, "mail", 0);
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), hInstance, 1, 90, "folder", 0);
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), hInstance, 2, 90, "disk", 0);
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), hInstance, 3, 130, "bug", "Item 4");
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), hInstance, 4, 90, 0, "Item 5");
            return 0;
        case WM_SIZE:
            GetClientRect(hwnd, &rc);
            hdl.prc = &rc;
            hdl.pwpos = &wp;
            SendDlgItemMessage(hwnd, ID_HEADER1, HDM_LAYOUT, 0, (LPARAM)&hdl);
            SetWindowPos(GetDlgItem(hwnd, ID_HEADER1), wp.hwndInsertAfter, wp.x, wp.y,
                wp.cx, wp.cy, wp.flags);
            break;
        case WM_NOTIFY:
            pnmhdr = (LPNMHEADER)lParam;
            switch(pnmhdr->hdr.code) {
                case HDN_ITEMSTATEICONCLICK:
                    MessageBox(hwnd, "Click estado", "Filtro", MB_OK);
                    break;
                case HDN_FILTERBTNCLICK:
                    iItem = pnmhdr->iItem+1;
                    sprintf(mensaje, "Botn de filtro de item %d activado", iItem);
                    MessageBox(hwnd, mensaje, "Filtro", MB_OK);
                    break;
                case HDN_DROPDOWN:
                    iItem = pnmhdr->iItem+1;
                    sprintf(mensaje, "Dropdown de item %d activado", iItem);
                    MessageBox(hwnd, mensaje, "Mensaje", MB_OK);
                    MessageBeep(MB_ICONHAND);
                    return FALSE;
            }
            break;
        case WM_DESTROY:
           DeleteObject(hFont);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

int InsertarItem(HWND hwndHeader, HINSTANCE hInstance, int iDespuesDe, int nAncho, char* bm, char *texto)
{
    HDITEM hdi;
    int index;

    hdi.mask = HDI_FORMAT | HDI_WIDTH;
    hdi.fmt = 0;
    if(bm) {
        hdi.mask |= HDI_BITMAP;
        if(texto) hdi.fmt |= HDF_BITMAP_ON_RIGHT;
        else hdi.fmt |= HDF_BITMAP;
        hdi.hbm = LoadBitmap(hInstance, bm);
    }
    if(texto) {
        hdi.mask |= HDI_TEXT;
        hdi.fmt |= HDF_STRING | HDF_CENTER;
        hdi.pszText = texto;
        hdi.cchTextMax = strlen(hdi.pszText)/sizeof(hdi.pszText[0]);
    }
    hdi.cxy = nAncho;
    index = SendMessage(hwndHeader, HDM_INSERTITEM,
        (WPARAM) iDespuesDe, (LPARAM) &hdi);

    return index;
}
