#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win094.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
BOOL InsertarItem(HWND hwnd, int iItem, int imagen, int imagensel, int indent, char *texto);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 094",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           250,                 /* Ancho */
           120,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    INITCOMMONCONTROLSEX icex;

    icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icex.dwICC = ICC_USEREX_CLASSES;

    InitCommonControlsEx(&icex);

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hFont;
    HIMAGELIST hIml;
    static HWND hCtrl;
    HBITMAP hbmp;
    LPNMHEADER pnmhdr;
    int c;
NMCOMBOBOXEX* nmCBE;
NMCBEENDEDIT* nmCEE;
    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hIml = ImageList_Create(24, 24, ILC_COLOR16|ILC_MASK, 19, 4);
            hbmp = LoadBitmap(hInstance, "imagenes");
            ImageList_AddMasked(hIml, hbmp,  RGB(255,255,255));
            DeleteObject(hbmp);
            hFont = CreateFont(18, 0, 0, 0, 300, FALSE, FALSE, FALSE,
                DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Times New Roman");
            hCtrl = CreateWindowEx(0, WC_COMBOBOXEX, NULL,
                WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | CBS_DROPDOWN | CBS_SORT,
                0, 0, 0, 200,
                hwnd, (HMENU)ID_COMBOBOXEX,
                hInstance, NULL);
            // Asignamos la fuente a nuestro gusto.
            SendMessage(hCtrl, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE, 0));
            SendMessage(hCtrl, CBEM_SETIMAGELIST,0,(LPARAM)hIml);
            // Insertar items:
            InsertarItem(hCtrl, 0, 9, 0, 0, "Reloj");
            InsertarItem(hCtrl, 1, 10, 1, 1, "Bateria");
            InsertarItem(hCtrl, 2, 11, 2, 2, "Usuario");
            InsertarItem(hCtrl, 3, 12, 3, 0, "Libro");
            InsertarItem(hCtrl, 4, 13, 4, 1, "Caja");
            InsertarItem(hCtrl, 5, 14, 5, 2, "Caf");
            InsertarItem(hCtrl, 6, 15, 6, 0, "Puzzle");
            InsertarItem(hCtrl, 7, 16, 7, 1, "Galletas");
            InsertarItem(hCtrl, 8, I_IMAGECALLBACK, I_IMAGECALLBACK, 2, LPSTR_TEXTCALLBACK);

            SendMessage(hCtrl, CB_SETCURSEL, (WPARAM)0, 0);

            SendMessage(hCtrl, CBEM_SETEXTENDEDSTYLE, (WPARAM)CBES_EX_CASESENSITIVE | CBES_EX_TEXTENDELLIPSIS,
                (LPARAM)CBES_EX_CASESENSITIVE | CBES_EX_TEXTENDELLIPSIS);
            SetWindowPos(hCtrl,NULL,20,20,150,120,SWP_NOACTIVATE);
            return 0;
        case WM_NOTIFY:
            pnmhdr = (LPNMHEADER)lParam;
            switch(pnmhdr->hdr.code) {
                case CBEN_BEGINEDIT:
                    return 0;
                    break;
                case CBEN_ENDEDIT:
                    nmCEE = (NMCBEENDEDIT*)lParam;
                    if(nmCEE->fChanged && nmCEE->iNewSelection == -1) {
                        InsertarItem(hCtrl, -1, 17, 8, 2, nmCEE->szText);
                        c = SendMessage(hCtrl, CB_GETCOUNT, 0, 0);
                        SendMessage(hCtrl, CB_SETCURSEL, (WPARAM)c, 0);
                    }
                    return 0;
                    break;
                case CBEN_INSERTITEM:
                    break;
                case CBEN_GETDISPINFO:
                    nmCBE = (NMCOMBOBOXEX*)lParam;
                    if( nmCBE->ceItem.mask & CBEIF_IMAGE)
                        nmCBE->ceItem.iImage = 17;
                    if( nmCBE->ceItem.mask & CBEIF_SELECTEDIMAGE)
                        nmCBE->ceItem.iSelectedImage = 8;
                    if( nmCBE->ceItem.mask & CBEIF_TEXT)
                        strcpy(nmCBE->ceItem.pszText, "Tierra");
                    nmCBE->ceItem.mask |= CBEIF_DI_SETITEM;
                    return 0;
                    break;
            }

            break;
        case WM_DESTROY:
            hIml = (HIMAGELIST)SendMessage(hCtrl, CBEM_GETIMAGELIST, 0, 0);
            ImageList_Destroy(hIml);
            DeleteObject(hFont);
            PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
            break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

BOOL InsertarItem(HWND hCtrl, int iItem, int imagen, int imagensel, int indent, char *texto) {
    COMBOBOXEXITEM cbei;

    int c;

    c = SendMessage(hCtrl, CB_GETCOUNT, 0, 0);
    cbei.mask = CBEIF_TEXT | CBEIF_INDENT |
            CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
    cbei.iItem          = c;
    cbei.pszText        = texto;
    cbei.iImage         = imagen;
    cbei.iSelectedImage = imagensel;
    cbei.iIndent        = indent;

    if(SendMessage(hCtrl, CBEM_INSERTITEM,0,(LPARAM)&cbei) == -1)
        return FALSE;
    return TRUE;
}

