#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win095.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DialogProcedure(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL InsertarItem(HWND hwnd, int id, int iItem, int imagen, int imagensel, int indent, char *texto);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 095",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           250,                 /* Ancho */
           100,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    INITCOMMONCONTROLSEX icex;

    icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icex.dwICC = ICC_USEREX_CLASSES;

    InitCommonControlsEx(&icex);

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            break;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case CM_DIALOGO:
                    DialogBoxParam(hInstance, "DialogoEx", hwnd, (DLGPROC)DialogProcedure, (LPARAM)hInstance);
                    break;
                case CM_SALIR:
                    PostQuitMessage(0);
                    break;
            }
            break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

BOOL CALLBACK DialogProcedure(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    HIMAGELIST hIml;
    HBITMAP hbmp;
    HFONT hfont;
    LPNMHEADER pnmhdr;
    NMCBEENDEDIT* nmCEE;
    RECT re;
    int c;

    switch(uMsg) {
        case WM_INITDIALOG:
            hIml = ImageList_Create(24, 24, ILC_COLOR16|ILC_MASK, 19, 4);
            hbmp = LoadBitmap((HINSTANCE)lParam, "imagenes");
            ImageList_AddMasked(hIml, hbmp,  RGB(255,255,255));
            DeleteObject(hbmp);
            hfont = CreateFont(-11, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Ms Shell Dlg"));

            re.top = 8;
            re.left = 9;
            re.bottom = 221;
            re.right = 81;
            MapDialogRect(hwndDlg, &re);

            CreateWindowEx(0, WC_COMBOBOXEX, NULL,
                WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | CBS_DROPDOWN | CBS_SORT | ES_WANTRETURN,
                re.top, re.left, re.bottom, re.right,
                hwndDlg, (HMENU)ID_COMBOBOXEX,
                (HINSTANCE)lParam, NULL);
            // Asignamos la fuente a nuestro gusto.
            SendDlgItemMessage(hwndDlg, ID_COMBOBOXEX, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwndDlg, ID_COMBOBOXEX, CBEM_SETIMAGELIST,0,(LPARAM)hIml);

            // Insertar items:
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 0, 9, 0, 0, "Reloj");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 1, 10, 1, 1, "Bateria");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 2, 11, 2, 2, "Usuario");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 3, 12, 3, 0, "Libro");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 4, 13, 4, 1, "Caja");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 5, 14, 5, 2, "Caf");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 6, 15, 6, 0, "Puzzle");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 7, 16, 7, 1, "Galletas");
            InsertarItem(hwndDlg, ID_COMBOBOXEX, 8, 17, 8, 2, "Tierra");

            SendDlgItemMessage(hwndDlg, ID_COMBOBOXEX, CB_SETCURSEL, (WPARAM)0, 0);

            return TRUE;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case IDOK:
                    EndDialog(hwndDlg, TRUE);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hwndDlg, FALSE);
                    return TRUE;
            }
            break;
        case WM_NOTIFY:
            pnmhdr = (LPNMHEADER)lParam;
            switch(pnmhdr->hdr.code) {
                case CBEN_ENDEDIT:
                    nmCEE = (NMCBEENDEDIT*)lParam;
                    if(nmCEE->fChanged && nmCEE->iNewSelection == -1) {
                        InsertarItem(hwndDlg, ID_COMBOBOXEX, -1, 17, 8, 2, nmCEE->szText);
                        c = SendDlgItemMessage(hwndDlg, ID_COMBOBOXEX, CB_GETCOUNT, 0, 0);
                        SendDlgItemMessage(hwndDlg, ID_COMBOBOXEX, CB_SETCURSEL, (WPARAM)c, 0);
                    }
                    return 0;
            }
            break;
    }
    return FALSE;
}

BOOL InsertarItem(HWND hwnd, int id, int iItem, int imagen, int imagensel, int indent, char *texto) {
    COMBOBOXEXITEM cbei;

    int c;

    c = SendDlgItemMessage(hwnd, ID_COMBOBOXEX, CB_GETCOUNT, 0, 0);
    cbei.mask = CBEIF_TEXT | CBEIF_INDENT |
            CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
    cbei.iItem          = c;
    cbei.pszText        = texto;
    cbei.iImage         = imagen;
    cbei.iSelectedImage = imagensel;
    cbei.iIndent        = indent;

    if(SendDlgItemMessage(hwnd, id, CBEM_INSERTITEM,0,(LPARAM)&cbei) == -1)
        return FALSE;
    return TRUE;
}

