#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win096.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void CalculaTamanoTexto(HWND hctrl, char* szcad, SIZE* lpsize);

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = 0;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 096",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           300,                 /* Ancho */
           300,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    HFONT hFont;
    static HFONT hFont2;
    SYSTEMTIME st;
    SYSTEMTIME rango[2];
    int v;
    NMHDR* pnmHdr;
    HWND hCMwnd;
    SIZE size;
    char* cad = "XX ddd dd'/'MM'/'yyy HH XXX";
    NMDATETIMEFORMATQUERY* pnmdtfq;
    NMDATETIMEFORMAT* pnmdtf;
    NMDATETIMESTRING* pnmdts;
    NMDATETIMEWMKEYDOWN* pnmdtk;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(-11, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Ms Shell Dlg"));
            hFont2 = CreateFont(-22, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Times New Roman"));
            CreateWindowEx(0, "STATIC", "Formato largo, rango, callback fields",
                WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,10,220,20,
                hwnd, (HMENU)(ET_DATETIME1),
                hInstance, NULL);
            CreateWindowEx(0, DATETIMEPICK_CLASS, NULL,
                WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP | DTS_LONGDATEFORMAT,
                10,30,2500,55,
                hwnd, (HMENU)ID_DATETIME1,
                hInstance, NULL);
            CreateWindowEx(0, "STATIC", "Formato corto, admite hoy, maana, ayer",
                WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,70,220,20,
                hwnd, (HMENU)(ET_DATETIME2),
                hInstance, NULL);
            CreateWindowEx(0, DATETIMEPICK_CLASS, NULL,
                WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP | DTS_SHORTDATEFORMAT | DTS_APPCANPARSE,
                10,90,220,30,
                hwnd, (HMENU)(ID_DATETIME2),
                hInstance, NULL);
            CreateWindowEx(0, "STATIC", "Sin fecha opcional",
                WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,130,220,20,
                hwnd, (HMENU)(ET_DATETIME3),
                hInstance, NULL);
            CreateWindowEx(0, DATETIMEPICK_CLASS, NULL,
                WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP | DTS_SHORTDATECENTURYFORMAT | DTS_SHOWNONE,
                10,150,220,30,
                hwnd, (HMENU)(ID_DATETIME3),
                hInstance, NULL);
            CreateWindowEx(0, "STATIC", "Hora up-down",
                WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,190,220,20,
                hwnd, (HMENU)(ET_DATETIME4),
                hInstance, NULL);
            CreateWindowEx(0, DATETIMEPICK_CLASS, NULL,
                WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP | DTS_TIMEFORMAT,
                10,210,220,30,
                hwnd, (HMENU)(ID_DATETIME4),
                hInstance, NULL);

            // Asignamos la fuente a nuestro gusto.
            SendDlgItemMessage(hwnd, ET_DATETIME1, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ET_DATETIME2, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ET_DATETIME3, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ET_DATETIME4, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));

            SendDlgItemMessage(hwnd, ID_DATETIME1, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_DATETIME2, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_DATETIME3, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_DATETIME4, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));

            // Asignar cadena de formato:
            SendDlgItemMessage(hwnd, ID_DATETIME1, DTM_SETFORMAT, 0, (LPARAM)cad);
//            DateTime_SetFormat(GetDlgItem(hwnd, ID_DATETIME1), cad);
            // Calcular tamao de control:
            SendDlgItemMessage(hwnd, ID_DATETIME1, DTM_GETIDEALSIZE, 0, (LPARAM)&size);
            // Redimensionar control:
            MoveWindow( GetDlgItem(hwnd, ID_DATETIME1), 10, 30, size.cx, 30, TRUE);

            SendDlgItemMessage(hwnd, ID_DATETIME2, DTM_GETIDEALSIZE, 0, (LPARAM)&size);
            MoveWindow( GetDlgItem(hwnd, ID_DATETIME2), 10, 90, size.cx, size.cy, TRUE);

            SendDlgItemMessage(hwnd, ID_DATETIME3, DTM_GETIDEALSIZE, 0, (LPARAM)&size);
            MoveWindow( GetDlgItem(hwnd, ID_DATETIME3), 10, 150, size.cx, size.cy, TRUE);

            GetLocalTime(&st);
            st.wYear = 2021;
            st.wMonth = 1;
            st.wDay = 15;
            v = SendDlgItemMessage(hwnd, ID_DATETIME1, DTM_SETSYSTEMTIME, (WPARAM)GDT_VALID, (LPARAM)&st);
            v = DateTime_SetSystemtime(GetDlgItem(hwnd, ID_DATETIME1), GDT_VALID, &st);
            rango[0].wYear = 2021;
            rango[0].wMonth = 1;
            rango[0].wDay = 15;
            rango[1].wYear = 2021;
            rango[1].wMonth = 12;
            rango[1].wDay = 15;
            // Asignar un rango:
            v = SendDlgItemMessage(hwnd, ID_DATETIME1, DTM_SETRANGE, (WPARAM)(GDTR_MIN | GDTR_MAX), (LPARAM)rango);
            //v = DateTime_SetSystemtime(GetDlgItem(hwnd, ID_DATETIME1), GDTR_MIN | GDTR_MAX, rango);
            // El cambio de color y fuente no afecta con los estilos visuales activos:
            SendDlgItemMessage(hwnd, ID_DATETIME3, DTM_SETMCCOLOR, (WPARAM)MCSC_BACKGROUND, (LPARAM)0x0000ff);
            // Usar otra fuente en este control:
            SendDlgItemMessage(hwnd, ID_DATETIME3, DTM_SETMCFONT, (WPARAM)hFont2, (LPARAM)TRUE);
            // Modificar los estilos del control de calendario:
            SendDlgItemMessage(hwnd, ID_DATETIME3, DTM_SETMCSTYLE, 0, (LPARAM)(MCS_SHORTDAYSOFWEEK | MCS_NOTODAY | MCS_WEEKNUMBERS | MCS_MULTISELECT | MCS_NOTRAILINGDATES));
            DateTime_SetMonthCalStyle(GetDlgItem(hwnd, ID_DATETIME3), (MCS_SHORTDAYSOFWEEK | MCS_NOTODAY | MCS_WEEKNUMBERS | MCS_MULTISELECT | MCS_NOTRAILINGDATES));
            break;
        case WM_NOTIFY:
            pnmHdr = (NMHDR*)lParam;
            switch(pnmHdr->code) {
                case DTN_DROPDOWN:
                    // Obtener un manipulador de ventana del control de calendario:
                    hCMwnd = (HWND)SendMessage(pnmHdr->hwndFrom, DTM_GETMONTHCAL, 0, 0);
                    hCMwnd = DateTime_GetMonthCal(pnmHdr->hwndFrom);
                    break;
                case DTN_CLOSEUP:
                    break;
                case DTN_FORMAT:
                    pnmdtf = (NMDATETIMEFORMAT*)lParam;
                    if(!strcmp(pnmdtf->pszFormat, "XX")) {
                       strcpy(pnmdtf->szDisplay,"Fecha:");
                    }
                    if(!strcmp(pnmdtf->pszFormat, "XXX")) {
                        if(pnmdtf->st.wHour >= 6 && pnmdtf->st.wHour < 15)
                            strcpy(pnmdtf->szDisplay, "maana");
                        else if(pnmdtf->st.wHour >= 15 && pnmdtf->st.wHour < 23)
                            strcpy(pnmdtf->szDisplay, "tarde");
                        else strcpy(pnmdtf->szDisplay, "noche");

                    }
                    return 0;
                case DTN_FORMATQUERY:
                    pnmdtfq = (NMDATETIMEFORMATQUERY*)lParam;
                    if(!strcmp(pnmdtfq->pszFormat, "XX")) {
                        CalculaTamanoTexto(GetDlgItem(hwnd, ID_DATETIME1), "Fecha:", &pnmdtfq->szMax);
                    }
                    if(!strcmp(pnmdtfq->pszFormat, "XXX")) {
                        CalculaTamanoTexto(GetDlgItem(hwnd, ID_DATETIME1), "maana", &pnmdtfq->szMax);
                    }
                    return 0;
                case DTN_WMKEYDOWN:
                    pnmdtk = (NMDATETIMEWMKEYDOWN*)lParam;
                    if(!strcmp(pnmdtk->pszFormat, "XXX")) {
                        if(pnmdtk->nVirtKey == 'M') {
                            pnmdtk->st.wHour=6;
                        }
                        if(pnmdtk->nVirtKey == 'T') {
                            pnmdtk->st.wHour=15;
                        }
                        if(pnmdtk->nVirtKey == 'N') {
                            pnmdtk->st.wHour=23;
                        }
                    }
                    return 0;
                case DTN_USERSTRING:
                    pnmdts = (NMDATETIMESTRING*)lParam;
                    if(!strcmp(pnmdts->pszUserString, "hoy"))
                        GetLocalTime(&(pnmdts->st));
                    else if(!strcmp(pnmdts->pszUserString, "maana")) {
                        GetLocalTime(&(pnmdts->st));
                        pnmdts->st.wDay++;
                    } else if(!strcmp(pnmdts->pszUserString, "ayer")) {
                        GetLocalTime(&(pnmdts->st));
                        pnmdts->st.wDay--;
                    }
                    return 0;
            }
            break;
        case WM_DESTROY:
            /* Obtener datos de los controles:
            v = SendDlgItemMessage(hwnd, ID_DATETIME1, DTM_GETSYSTEMTIME, 0, (LPARAM)&st);
            v = DateTime_GetSystemtime(GetDlgItem(hwnd, ID_DATETIME1), (LPARAM)&st);
            v = SendDlgItemMessage(hwnd, ID_DATETIME1, DTM_GETRANGE, 0, (LPARAM)rango);
            v = DateTime_GetSystemtime(GetDlgItem(hwnd, ID_DATETIME1), rango); */
            hFont = (HFONT)SendDlgItemMessage(hwnd, ID_DATETIME1, WM_GETFONT, 0, 0);
            DeleteObject(hFont);
            DeleteObject(hFont2);
            PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
            break;
        default:                  /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

void CalculaTamanoTexto(HWND hctrl, char* szcad, SIZE* lpsize) {
    HDC hdc;

    hdc = GetDC(hctrl);
    GetTextExtentPoint32(hdc, szcad, strlen(szcad), lpsize);
    ReleaseDC(hctrl, hdc);
}
