#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <time.h>

#include "win098.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
MONTHDAYSTATE CalcularEstados(SYSTEMTIME* fecha);
BOOL CALLBACK DialogProcedure(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 098",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           600,                 /* Ancho */
           670,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static SYSTEMTIME fecha;
    HFONT hFont;
    RECT re;
    HDC hdc;
    MONTHDAYSTATE estados[14];
    LPNMDAYSTATE lpnmDS;
    MCGRIDINFO mcGI;
    WCHAR cad[100];
    char cad2[100];
    static int x;
    int i;
    NMHDR* pnmhdr;
    NMSELCHANGE* pnmSC;
    NMVIEWCHANGE* pnmVC;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            GetLocalTime(&fecha);
            hFont = CreateFont(-14, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Ms Shell Dlg"));
            CreateWindowEx(0, "STATIC", "Calendario",
                WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,10,220,20,
                hwnd, (HMENU)(ET_CALENDAR1),
                hInstance, NULL);
            CreateWindowEx(0, MONTHCAL_CLASS, NULL,
                WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP | MCS_DAYSTATE | MCS_MULTISELECT,
                10,10,600,200,
                hwnd, (HMENU)ID_CALENDAR1,
                hInstance, NULL);
            SendDlgItemMessage(hwnd, ET_CALENDAR1, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_CALENDAR1, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SETCALENDARBORDER, (WPARAM)FALSE, (LPARAM)10);
            re.top = 10;
            re.left = 10;
            re.right = 600;
            re.bottom = 700;
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SIZERECTTOMIN, 0, (LPARAM)&re);
            MoveWindow( GetDlgItem(hwnd, ID_CALENDAR1), 10, 30, re.right, re.bottom, TRUE);

            fecha.wDay = 5;
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SETCURSEL, 0, (LPARAM)&fecha);
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SETMAXSELCOUNT, (WPARAM)30, 0);

            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SETFIRSTDAYOFWEEK, 0, (LPARAM)0);
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SETMONTHDELTA, (WPARAM)3, 0);
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_GETMONTHRANGE, (WPARAM)GMR_VISIBLE, (LPARAM)&fecha);

            mcGI.cbSize = sizeof(MCGRIDINFO);
            mcGI.dwPart = MCGIP_CALENDAR;
            mcGI.iCalendar = 1;
            mcGI.pszName = cad;
            mcGI.cchName = 100;
            mcGI.dwFlags = MCGIF_NAME;
            SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_GETCALENDARGRIDINFO, 0, (LPARAM)&mcGI);
            wsprintf(cad2, "%S\n", cad);
            printf(cad2);
            break;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case CM_DIALOGO:
                    DialogBoxParam(hInstance, "Dialogo", hwnd, (DLGPROC)DialogProcedure, (LPARAM)&fecha);
                    break;
                case CM_SALIR:
                    PostQuitMessage(0);
                    break;
            }
            break;
        case WM_NOTIFY:
            pnmhdr = (NMHDR*)lParam;
            switch(pnmhdr->code) {
                case MCN_GETDAYSTATE:
                    lpnmDS = (LPNMDAYSTATE)lParam;
                    for(i = 0; i < lpnmDS->cDayState; i++) {
                        estados[i] = CalcularEstados(&lpnmDS->stStart);
                        lpnmDS->stStart.wMonth++;
                        if(lpnmDS->stStart.wMonth == 13) {
                            lpnmDS->stStart.wMonth = 1;
                            lpnmDS->stStart.wYear++;
                        }
                    }
                    lpnmDS->prgDayState = estados;
                    return 1;
                case MCN_SELCHANGE:
                    pnmSC = (NMSELCHANGE*)lParam;
                    break;
                case MCN_SELECT:
                    pnmSC = (NMSELCHANGE*)lParam;
                    break;
                case MCN_VIEWCHANGE:
                    pnmVC = (NMVIEWCHANGE*)lParam;
                    //SendDlgItemMessage(hwnd, ID_CALENDAR1, MCM_SETCURRENTVIEW, 0, (LPARAM)MCMV_MONTH);
                    break;
            }
            return 0;
        case WM_DESTROY:
            PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
            break;
        default:                  /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

MONTHDAYSTATE CalcularEstados(SYSTEMTIME* fecha) {
    MONTHDAYSTATE estado = 0;
    int i;
    int dds;
    struct tm t;

    // Ajustar da de la semana
    t.tm_year = fecha->wYear-1900;
    t.tm_mon = fecha->wMonth-1;
    t.tm_mday = 1;
    t.tm_hour = 12;
    t.tm_min = t.tm_sec = 0;
    mktime(&t);

    dds = t.tm_wday;
    for(i = 0; i < 32; i++) {
        estado >>= 1;
        if(dds == 0 || dds == 6) estado |= 0x80000000U;
        dds = (dds+1)%7;
    }
    return estado;
}

BOOL CALLBACK DialogProcedure(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    static SYSTEMTIME* fecha;

    switch(uMsg) {
        case WM_INITDIALOG:
            fecha = (SYSTEMTIME*)lParam;
            return TRUE;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case IDOK:
                    SendDlgItemMessage(hwndDlg, ID_CALENDAR1, DTM_GETSYSTEMTIME, 0, (LPARAM)fecha);
                    EndDialog(hwndDlg, TRUE);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hwndDlg, FALSE);
                    return TRUE;
            }
            break;
    }
    return FALSE;
}

