#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win099.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */
    INITCOMMONCONTROLSEX iCCE;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 099",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           460,                 /* Ancho */
           420,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    iCCE.dwSize = sizeof(INITCOMMONCONTROLSEX);
    iCCE.dwICC = ICC_BAR_CLASSES;
    InitCommonControlsEx(&iCCE);

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HWND hCtrl;
    HFONT hFont;
    char cad[100];
    static DWORD posicion;
    static HWND hToolPrev, hToolNew;
    LPNMHDR pnmhdr;
    LPNMTTDISPINFO pnmttdispinfo;
    TOOLINFO toolInfo = { 0 };
    HWND hctrl;
    NMTRBTHUMBPOSCHANGING* pnmtpc;
    HDC hdc;
    RECT wre;
    POINT punto;
    HDC memDC;
    static HBITMAP hBitmapRes;
    char* szReason[] = {
            "TB_LINEUP",
            "TB_LINEDOWN",
            "TB_PAGEUP",
            "TB_PAGEDOWN",
            "TB_THUMBPOSITION",
            "TB_THUMBTRACK",
            "TB_TOP",
            "TB_BOTTOM",
            "TB_ENDTRACK"
    };

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(-14, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Ms Shell Dlg"));
            hCtrl = CreateWindowEx(0, TRACKBAR_CLASS, NULL,
                WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_TOOLTIPS | TBS_AUTOTICKS | TBS_BOTH | TBS_ENABLESELRANGE | TBS_NOTIFYBEFOREMOVE | TBS_TRANSPARENTBKGND, // | TBS_NOTIFYBEFOREMOVE, //  | TBS_AUTOTICKS | TBS_BOTH | TBS_VERT | TBS_ENABLESELRANGE | TBS_FIXEDLENGTH
                80,10,300,50,
                hwnd, (HMENU)ID_TRACKBAR,
                hInstance, NULL);
            CreateWindowEx(0, "STATIC", "", WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                80,70,220,20, hwnd, (HMENU)(ET_TRACKBAR),
                hInstance, NULL);
            SendDlgItemMessage(hwnd, ET_TRACKBAR, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            CreateWindowEx(0, TRACKBAR_CLASS, NULL,
                WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_VERT | TBS_TOOLTIPS | TBS_AUTOTICKS | TBS_RIGHT | TBS_FIXEDLENGTH, // | TBS_TRANSPARENTBKGND, // | TBS_NOTIFYBEFOREMOVE, //  | TBS_AUTOTICKS | TBS_BOTH | TBS_VERT | TBS_ENABLESELRANGE
                20,60,40,300,
                hwnd, (HMENU)ID_TRACKBAR2,
                hInstance, NULL);

            hBitmapRes = LoadBitmap(hInstance, "rojo");
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETTICFREQ, (WPARAM)5, 0);
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETSEL, (WPARAM)TRUE, MAKELPARAM(30, 70));

            SendDlgItemMessage(hwnd, ID_TRACKBAR2, TBM_SETRANGEMIN, (WPARAM)FALSE, (LPARAM)-50);
            SendDlgItemMessage(hwnd, ID_TRACKBAR2, TBM_SETRANGEMAX, (WPARAM)FALSE, (LPARAM)50);
            SendDlgItemMessage(hwnd, ID_TRACKBAR2, TBM_SETTICFREQ, (WPARAM)10, 0);
            SendDlgItemMessage(hwnd, ID_TRACKBAR2, TBM_SETPOS, (WPARAM)TRUE, (LPARAM)0);

            SendDlgItemMessage(hwnd, ID_TRACKBAR2, TBM_SETTHUMBLENGTH, (WPARAM)15, 0);

            SetTimer(hwnd, 1, 200, NULL);
            posicion = 0;
            hToolNew = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLTIPS_CLASS, NULL,
                              WS_POPUP | TTS_ALWAYSTIP,
                              CW_USEDEFAULT, CW_USEDEFAULT,
                              CW_USEDEFAULT, CW_USEDEFAULT,
                              hwnd, NULL,
                              hInstance, NULL);
            if(hToolNew) {
                SetWindowPos(hToolNew, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
                SendMessage(hToolNew, TTM_SETMAXTIPWIDTH, 0, 150);

                toolInfo.cbSize = sizeof(toolInfo);
                toolInfo.hwnd = hCtrl;;
                toolInfo.hinst = hInstance;
                toolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
                toolInfo.uId = (UINT_PTR)GetDlgItem(hwnd, ID_TRACKBAR);
                toolInfo.lpszText = LPSTR_TEXTCALLBACK;
                SendMessage(hToolNew, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);

                hToolPrev = (HWND)SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_GETTOOLTIPS, 0, 0);
                SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETTOOLTIPS, (WPARAM)hToolNew, 0);
            }
//            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETTIPSIDE, (WPARAM)TBTS_BOTTOM, 0);
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETLINESIZE, 0, (LPARAM)2);
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETPAGESIZE, 0, (LPARAM)10);
/*            hctrl = CreateWindowEx(0, "BUTTON", (LPSTR)"Botn", WS_CHILD | WS_VISIBLE, 10, 10, 60, 24, hwnd,
                          (HMENU)(120), hInstance, NULL);*/
            hctrl = CreateWindowEx(0, "STATIC", "izquierda", WS_CHILD | WS_VISIBLE | SS_SIMPLE, 0,0,60,20, hwnd, NULL, hInstance, NULL);
            SendMessage(hctrl, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETBUDDY, (WPARAM)TRUE, (LPARAM)hctrl);
            hctrl = CreateWindowEx(0, "STATIC", "derecha", WS_CHILD | WS_VISIBLE | SS_SIMPLE, 0,0,60,20, hwnd, NULL, hInstance, NULL);
            SendMessage(hctrl, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETBUDDY, (WPARAM)FALSE, (LPARAM)hctrl);
            break;
        case WM_PRINTCLIENT:
            GetWindowRect(hCtrl, &wre);
            wre.right -= wre.left;
            wre.bottom -= wre.top;
            punto.x = wre.left;
            punto.y = wre.top;
            ScreenToClient(hwnd, &punto);
            hdc = (HDC)wParam;
            memDC = CreateCompatibleDC(hdc);
            SelectObject(memDC, hBitmapRes);
            BitBlt(hdc, punto.x, punto.y, wre.right, wre.bottom, memDC, 0, 0, SRCCOPY);
            DeleteDC(memDC);
            break;
        case WM_TIMER:
            KillTimer(hwnd, 1);
            SendDlgItemMessage(hwnd, ID_TRACKBAR, TBM_SETPOS, (WPARAM)TRUE, (LPARAM)posicion++);
            SetTimer(hwnd, 1, 200, NULL);
            break;
        case WM_NOTIFY:
           pnmhdr = (LPNMHDR)lParam;
           switch(pnmhdr->code) {
            case TRBN_THUMBPOSCHANGING:
                pnmtpc = (NMTRBTHUMBPOSCHANGING*)pnmhdr;
                sprintf(cad, "%99s", " ");
                SetWindowText(GetDlgItem(hwnd, ET_TRACKBAR), cad);
                sprintf(cad, "%-25s -> %8ld\n", szReason[pnmtpc->nReason], (long)pnmtpc->dwPos);
                SetWindowText(GetDlgItem(hwnd, ET_TRACKBAR), cad);
                break;
            case TTN_GETDISPINFO:
                pnmttdispinfo = (LPNMTTDISPINFO)pnmhdr;
                if(GetDlgCtrlID((HWND)pnmttdispinfo->hdr.idFrom) == ID_TRACKBAR) {
                    sprintf(cad, "Valor: %ld", (long)SendMessage(hCtrl, TBM_GETPOS, 0, 0));
                    strcpy(pnmttdispinfo->lpszText, cad);
                }
                break;
           }
           break;
        case WM_DESTROY:
            DeleteObject(hBitmapRes);
            PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
            break;
        default:                  /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
